/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20061109
 *
 * Disassembly of (null), Thu Jun 07 15:03:07 2007
 *
 *
 * Original Table Header:
 *     Signature        "DSDT"
 *     Length           0x00004C79 (19577)
 *     Revision         0x01
 *     OEM ID           "FIC   "
 *     OEM Table ID     "XTB70   "
 *     OEM Revision     0x06040000 (100925440)
 *     Creator ID       "MSFT"
 *     Creator Revision 0x0100000E (16777230)
 */
DefinitionBlock ("DSDT.aml", "DSDT", 1, "FIC   ", "XTB70   ", 0x06040000)
{
    External (\_PR_.CPU0.XPPC, IntObj)

    Name (\_S0, Package (0x04)
    {
        0x00, 
        0x00, 
        0x00, 
        0x00
    })
    Name (\_S3, Package (0x04)
    {
        0x05, 
        0x05, 
        0x00, 
        0x00
    })
    Name (\_S4, Package (0x04)
    {
        0x06, 
        0x06, 
        0x00, 
        0x00
    })
    Name (\_S5, Package (0x04)
    {
        0x07, 
        0x07, 
        0x00, 
        0x00
    })
    Name (SX, 0x00)
    Name (ACON, 0x01)
    Method (\_PTS, 1, NotSerialized)
    {
        Store (Arg0, DBUG)
        Store (0x04, Z000)
        If (LGreater (Arg0, 0x01))
        {
            Store (Zero, LDTC)
            Store (0x04, Z001)
            Store (0x04, Z002)
            Store (0x04, Z003)
        }

        If (LEqual (Arg0, 0x03))
        {
            \_SB.Z004 (0x52)
            If (\_OSI ("Windows 2006"))
            {
                Store (0x01, DOSF)
            }
            Else
            {
                Store (0x00, DOSF)
            }

            Or (\_SB.PCI0.LPC0.PMRD (0xE0), 0x01, Local0)
            \_SB.PCI0.LPC0.PMWT (0xE0, Local0)
        }
    }

    Method (\_WAK, 1, NotSerialized)
    {
        Store (Arg0, DBUG)
        Store (0x05, Z000)
        Store (0x05, Z005)
        Store (0x01, \_TZ.THRM.THIN)
        If (LEqual (Arg0, 0x03))
        {
            \_SB.Z004 (0x53)
            And (\_SB.PCI0.LPC0.PMRD (0xE0), 0xFE, Local0)
            \_SB.PCI0.LPC0.PMWT (0xE0, Local0)
            And (\_SB.PCI0.LPC0.PMRD (0xA0), 0x01, ACON)
            Notify (\_PR.CPU0, 0x80)
        }

        If (LEqual (Arg0, 0x04))
        {
            Notify (\_SB.PWRB, 0x02)
            And (\_SB.PCI0.LPC0.PMRD (0xA0), 0x01, ACON)
            Notify (\_PR.CPU0, 0x80)
            Store (0x01, \_SB.LID.LIDF)
        }

        \_TZ.THRM.TCHK ()
    }

    Scope (\_PR)
    {
        Processor (CPU0, 0x00, 0x00001010, 0x06)
        {
            Method (_PPC, 0, NotSerialized)
            {
                If (\_TZ.THRM.SPDF)
                {
                    Return (\_PR.CPU0.XPPC)
                }
                Else
                {
                    If (ACON)
                    {
                        Return (0x00)
                    }
                    Else
                    {
                        Return (\_PR.CPU0.XPPC)
                    }
                }
            }
        }

        Processor (CPU1, 0x01, 0x00001010, 0x06)
        {
            Method (_PPC, 0, NotSerialized)
            {
                If (\_TZ.THRM.SPDF)
                {
                    Return (\_PR.CPU0.XPPC)
                }
                Else
                {
                    If (ACON)
                    {
                        Return (0x00)
                    }
                    Else
                    {
                        Return (\_PR.CPU0.XPPC)
                    }
                }
            }
        }
    }

    Scope (\_SI)
    {
        Method (_SST, 1, NotSerialized)
        {
            Store ("==== SST Working ====", Debug)
        }

        Method (_MSG, 1, NotSerialized)
        {
        }
    }

    Scope (\_GPE)
    {
        Mutex (GLCK, 0x00)
        Method (_L01, 0, NotSerialized)
        {
            Acquire (\_GPE.GLCK, 0xFFFF)
            If (\_OSI ("Windows 2006"))
            {
                Store (0x01, DOSF)
            }
            Else
            {
                Store (0x00, DOSF)
            }

            Store (0xA1, DBUG)
            \_SB.Z004 (0x50)
            If (LEqual (\_SB.PCI0.LPC0.PMRD (0xF0), 0xF1))
            {
                Notify (\_SB.SLPB, 0x80)
            }

            If (LEqual (\_SB.PCI0.LPC0.PMRD (0xF0), 0xF3))
            {
                Notify (\_SB.PCI0.XVR0.VGA, 0x80)
            }

            If (LEqual (\_SB.PCI0.LPC0.PMRD (0xF0), 0xF8))
            {
                Notify (\_SB.PCI0.XVR0.VGA.LCD, 0x86)
            }

            If (LEqual (\_SB.PCI0.LPC0.PMRD (0xF0), 0xF9))
            {
                Notify (\_SB.PCI0.XVR0.VGA.LCD, 0x87)
            }

            \_SB.PCI0.LPC0.PMWT (0xF0, 0x00)
            Release (\_GPE.GLCK)
        }

        Method (_L0B, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.MAC0, 0x02)
        }

        Method (_L10, 0, NotSerialized)
        {
            Store (0xB0, DBUG)
            Acquire (\_GPE.GLCK, 0xFFFF)
            Store (\_SB.PCI0.LPC0.PMRD (0xAB), Local0)
            Store (\_SB.PCI0.LPC0.PMRD (0xAF), Local4)
            And (Local4, 0x04, Local7)
            If (LNotEqual (Local7, Zero))
            {
                \_SB.PCI0.LPC0.PMMW (0x043F, 0xAA)
                \_SB.PCI0.LPC0.PMMW (0x01E8, 0x00)
                Store (0x01, \_TZ.THRM.TERR)
            }

            If (LGreaterEqual (Local4, 0x01))
            {
                \_TZ.THRM.TCHK ()
            }

            If (And (Local0, 0x01, Local3))
            {
                And (\_SB.PCI0.LPC0.PMRD (0xA0), 0x01, ACON)
                Notify (\_PR.CPU0, 0x80)
                Notify (\_SB.PCI0.LPC0.ACAD, 0x80)
                Notify (\_PR.CPU0, 0x81)
                And (\_SB.PCI0.LPC0.PMRD (0xAB), 0xFE, Local2)
                \_SB.PCI0.LPC0.PMWT (0xAB, Local2)
                \_SB.PCI0.LPC0.PMMW (0x01E8, 0x00)
                And (\_SB.PCI0.LPC0.PMRD (0xAF), 0xFB, Local3)
                \_SB.PCI0.LPC0.PMWT (0xAF, Local3)
                If (\_OSI ("Windows 2006"))
                {
                    Return (0x00)
                }
                Else
                {
                    \_SB.Z004 (0x51)
                }
            }

            If (And (Local0, 0x02, Local3))
            {
                Notify (\_SB.PCI0.LPC0.ACAD, 0x80)
                Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local1)
                Store (\_SB.PCI0.LPC0.PMRD (0xF1), Local4)
                If (LNotEqual (And (Local1, 0x01, Local3), And (Local4, 0x01, 
                    Local5)))
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local6)
                    \_SB.PCI0.LPC0.PMWT (0xF1, Local6)
                    Notify (\_SB.PCI0.LPC0.BAT0, 0x81)
                }

                If (LNotEqual (And (Local1, 0x02, Local3), And (Local4, 0x02, 
                    Local5)))
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local6)
                    \_SB.PCI0.LPC0.PMWT (0xF1, Local6)
                    Notify (\_SB.PCI0.LPC0.BAT0, 0x80)
                }

                If (LNotEqual (And (Local1, 0x04, Local3), And (Local4, 0x04, 
                    Local5)))
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local6)
                    \_SB.PCI0.LPC0.PMWT (0xF1, Local6)
                    Notify (\_SB.PCI0.LPC0.BAT0, 0x80)
                }

                If (LNotEqual (And (Local1, 0x08, Local3), And (Local4, 0x08, 
                    Local5)))
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local6)
                    \_SB.PCI0.LPC0.PMWT (0xF1, Local6)
                    Notify (\_SB.PCI0.LPC0.BAT0, 0x80)
                }

                If (LNotEqual (And (Local1, 0x10, Local3), And (Local4, 0x10, 
                    Local5)))
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local6)
                    \_SB.PCI0.LPC0.PMWT (0xF1, Local6)
                    Notify (\_SB.PCI0.LPC0.BAT0, 0x80)
                }

                If (LNotEqual (And (Local1, 0x20, Local3), And (Local4, 0x20, 
                    Local5)))
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local6)
                    \_SB.PCI0.LPC0.PMWT (0xF1, Local6)
                    Notify (\_SB.PCI0.LPC0.BAT0, 0x80)
                }

                If (LNotEqual (And (Local1, 0x40, Local3), And (Local4, 0x40, 
                    Local5)))
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local6)
                    \_SB.PCI0.LPC0.PMWT (0xF1, Local6)
                    Notify (\_SB.PCI0.LPC0.BAT0, 0x80)
                }

                If (LNotEqual (And (Local1, 0x80, Local3), And (Local4, 0x80, 
                    Local5)))
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local6)
                    \_SB.PCI0.LPC0.PMWT (0xF1, Local6)
                    Notify (\_SB.PCI0.LPC0.BAT0, 0x80)
                }

                And (\_SB.PCI0.LPC0.PMRD (0xAB), 0xFD, Local2)
                \_SB.PCI0.LPC0.PMWT (0xAB, Local2)
            }

            Release (\_GPE.GLCK)
        }

        Method (_L12, 0, NotSerialized)
        {
            Store (0xB2, DBUG)
            Acquire (\_GPE.GLCK, 0xFFFF)
            Store (0x01, \_SB.LID.LIDF)
            Notify (\_SB.LID, 0x80)
            Store (\_SB.PCI0.LPC0.PMRD (0xB8), Local4)
            Store (\_SB.PCI0.LPC0.PMRD (0xB7), Local5)
            And (Local4, 0xFE, Local4)
            \_SB.PCI0.LPC0.PMWT (0xB8, Local4)
            If (And (\_SB.PCI0.LPC0.PMRD (0xB5), 0x01))
            {
                Store (\_SB.PCI0.LPC0.PMRD (0xB7), Local7)
                And (Local7, 0xFE, Local7)
                \_SB.PCI0.LPC0.PMWT (0xB7, Local7)
                \_SB.PCI0.LPC0.PMWT (0xFD, 0x00)
                Store (0x01, \_SB.LID.LIDF)
            }
            Else
            {
                Store (\_SB.PCI0.LPC0.PMRD (0xB7), Local7)
                Or (Local7, 0x01, Local7)
                \_SB.PCI0.LPC0.PMWT (0xB7, Local7)
                \_SB.PCI0.LPC0.PMWT (0xFD, 0x01)
                Store (0x00, \_SB.LID.LIDF)
            }

            Store (\_SB.PCI0.LPC0.PMRD (0xA8), Local6)
            And (Local6, 0xFE, Local6)
            \_SB.PCI0.LPC0.PMWT (0xA8, Local6)
            Or (Local4, 0x01, Local4)
            \_SB.PCI0.LPC0.PMWT (0xB8, Local4)
            Notify (\_SB.LID, 0x80)
            And (\_SB.PCI0.LPC0.PMRD (0xAC), 0xEF, Local7)
            \_SB.PCI0.LPC0.PMWT (0xAC, Local7)
            Release (\_GPE.GLCK)
        }

        Method (_L14, 0, NotSerialized)
        {
            Store (0xB4, DBUG)
            Notify (\_SB.PCI0.XVR2, 0x00)
        }
    }

    Scope (\_SB)
    {
        Device (PWRB)
        {
            Name (_HID, EisaId ("PNP0C0C"))
            Method (_STA, 0, NotSerialized)
            {
                Return (0x0B)
            }
        }

        Device (SLPB)
        {
            Name (_HID, EisaId ("PNP0C0E"))
        }

        Device (MEM0)
        {
            Name (_HID, EisaId ("PNP0C01"))
            Method (_CRS, 0, Serialized)
            {
                Name (MEMR, ResourceTemplate ()
                {
                    Memory32Fixed (ReadOnly,
                        0xFFC00000,         // Address Base
                        0x00400000,         // Address Length
                        )
                    Memory32Fixed (ReadWrite,
                        0xFEC00000,         // Address Base
                        0x00001000,         // Address Length
                        )
                    Memory32Fixed (ReadWrite,
                        0xFEE00000,         // Address Base
                        0x00100000,         // Address Length
                        )
                    Memory32Fixed (ReadWrite,
                        0x00000000,         // Address Base
                        0x00000000,         // Address Length
                        _Y00)
                })
                CreateDWordField (MEMR, \_SB.MEM0._CRS._Y00._BAS, MBAS)
                CreateDWordField (MEMR, \_SB.MEM0._CRS._Y00._LEN, MBLE)
                If (\_SB.PCI0.LPC0.MTBA)
                {
                    Store (\_SB.PCI0.LPC0.MTBA, MBAS)
                    Store (0x1000, MBLE)
                }

                Return (MEMR)
            }
        }

        Device (PCI0)
        {
            Name (_ADR, 0x00)
            Name (_HID, EisaId ("PNP0A03"))
            Name (_UID, 0x01)
            Method (_INI, 0, NotSerialized)
            {
                And (\_SB.PCI0.LPC0.PMRD (0xA0), 0x01, ACON)
                Store (0x00, THRG)
            }

            Method (_S3D, 0, NotSerialized)
            {
                Return (0x01)
            }

            Method (_STA, 0, NotSerialized)
            {
                Return (0x0F)
            }

            Scope (\_SB)
            {
                OperationRegion (ASLD, SystemMemory, 0x7FF6AE4C, 0x00000100)
                Field (ASLD, AnyAcc, NoLock, Preserve)
                {
                    TOM,    32, 
                    R_ST,   1, 
                        ,   3, 
                    R_P0,   4, 
                    R_S0,   4, 
                    R_S1,   4, 
                    RSS0,   4, 
                    RSS1,   4
                }
            }

            Method (_CRS, 0, NotSerialized)
            {
                Name (CBUF, ResourceTemplate ()
                {
                    WordBusNumber (ResourceProducer, MinFixed, MaxFixed, PosDecode,
                        0x0000,             // Granularity
                        0x0000,             // Range Minimum
                        0x00FF,             // Range Maximum
                        0x0000,             // Translation Offset
                        0x0100,             // Length
                        ,, )
                    IO (Decode16,
                        0x0CF8,             // Range Minimum
                        0x0CF8,             // Range Maximum
                        0x01,               // Alignment
                        0x08,               // Length
                        )
                    WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                        0x0000,             // Granularity
                        0x0000,             // Range Minimum
                        0x0CF7,             // Range Maximum
                        0x0000,             // Translation Offset
                        0x0CF8,             // Length
                        ,, , TypeStatic)
                    WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                        0x0000,             // Granularity
                        0x0D00,             // Range Minimum
                        0xFFFF,             // Range Maximum
                        0x0000,             // Translation Offset
                        0xF300,             // Length
                        ,, , TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000A0000,         // Range Minimum
                        0x000BFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00020000,         // Length
                        ,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000C0000,         // Range Minimum
                        0x000C3FFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000C4000,         // Range Minimum
                        0x000C7FFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000C8000,         // Range Minimum
                        0x000CBFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000CC000,         // Range Minimum
                        0x000CFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000D0000,         // Range Minimum
                        0x000D3FFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000D4000,         // Range Minimum
                        0x000D7FFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000D8000,         // Range Minimum
                        0x000DBFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000DC000,         // Range Minimum
                        0x000DFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000E0000,         // Range Minimum
                        0x000E3FFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000E4000,         // Range Minimum
                        0x000E7FFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000E8000,         // Range Minimum
                        0x000EBFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000EC000,         // Range Minimum
                        0x000EFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00004000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000F0000,         // Range Minimum
                        0x000FFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00010000,         // Length
                        0x00,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x00100000,         // Range Minimum
                        0xFEBFFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0xFFF00000,         // Length
                        ,, _Y01, AddressRangeMemory, TypeStatic)
                })
                CreateDWordField (CBUF, \_SB.PCI0._CRS._Y01._MIN, PMMN)
                CreateDWordField (CBUF, \_SB.PCI0._CRS._Y01._LEN, PMLN)
                Multiply (\_SB.TOM, 0x00100000, PMMN)
                Subtract (0xFEC00000, PMMN, PMLN)
                Return (CBUF)
            }

            Name (_PRT, Package (0x0C)
            {
                Package (0x04)
                {
                    0x000AFFFF, 
                    0x00, 
                    \_SB.PCI0.LSMB, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x000AFFFF, 
                    0x01, 
                    \_SB.PCI0.LPMU, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x000BFFFF, 
                    0x00, 
                    \_SB.PCI0.LUS0, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x000BFFFF, 
                    0x01, 
                    \_SB.PCI0.LUS2, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x0014FFFF, 
                    0x00, 
                    \_SB.PCI0.LMAC, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x0010FFFF, 
                    0x01, 
                    \_SB.PCI0.LAZA, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x000DFFFF, 
                    0x00, 
                    \_SB.PCI0.LPID, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x000EFFFF, 
                    0x00, 
                    \_SB.PCI0.LTID, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x0005FFFF, 
                    0x00, 
                    \_SB.PCI0.LK3E, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x0005FFFF, 
                    0x01, 
                    \_SB.PCI0.LK4E, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x0005FFFF, 
                    0x02, 
                    \_SB.PCI0.LK1E, 
                    0x00
                }, 

                Package (0x04)
                {
                    0x0005FFFF, 
                    0x03, 
                    \_SB.PCI0.LK2E, 
                    0x00
                }
            })
            Device (LPC0)
            {
                Name (_ADR, 0x000A0000)
                OperationRegion (P44, PCI_Config, 0x44, 0x04)
                Field (P44, AnyAcc, NoLock, Preserve)
                {
                    MTBA,   32
                }

                Device (MBRD)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x1F)
                    Name (RSRC, ResourceTemplate ()
                    {
                        Memory32Fixed (ReadWrite,
                            0xE0000000,         // Address Base
                            0x10000000,         // Address Length
                            )
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        Return (RSRC)
                    }
                }

                Device (PMIO)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x03)
                    Method (_CRS, 0, NotSerialized)
                    {
                        Name (IODM, ResourceTemplate ()
                        {
                            IO (Decode16,
                                0x0000,             // Range Minimum
                                0x0000,             // Range Maximum
                                0x00,               // Alignment
                                0x00,               // Length
                                )
                        })
                        Name (IORT, ResourceTemplate ()
                        {
                            IO (Decode16,
                                0x0000,             // Range Minimum
                                0x0000,             // Range Maximum
                                0x01,               // Alignment
                                0x80,               // Length
                                _Y02)
                            IO (Decode16,
                                0x0000,             // Range Minimum
                                0x0000,             // Range Maximum
                                0x01,               // Alignment
                                0x80,               // Length
                                _Y03)
                            IO (Decode16,
                                0x0000,             // Range Minimum
                                0x0000,             // Range Maximum
                                0x01,               // Alignment
                                0x80,               // Length
                                _Y04)
                            IO (Decode16,
                                0x0000,             // Range Minimum
                                0x0000,             // Range Maximum
                                0x01,               // Alignment
                                0x80,               // Length
                                _Y05)
                            IO (Decode16,
                                0x0000,             // Range Minimum
                                0x0000,             // Range Maximum
                                0x01,               // Alignment
                                0x80,               // Length
                                _Y06)
                            IO (Decode16,
                                0x0000,             // Range Minimum
                                0x0000,             // Range Maximum
                                0x01,               // Alignment
                                0x80,               // Length
                                _Y07)
                        })
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y02._MIN, I1MN)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y02._MAX, I1MX)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y03._MIN, I2MN)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y03._MAX, I2MX)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y04._MIN, I3MN)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y04._MAX, I3MX)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y05._MIN, I4MN)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y05._MAX, I4MX)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y06._MIN, I5MN)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y06._MAX, I5MX)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y07._MIN, I6MN)
                        CreateWordField (IORT, \_SB.PCI0.LPC0.PMIO._CRS._Y07._MAX, I6MX)
                        And (\_SB.PCI0.SMB0.PMBR, 0xFFFC, I1MN)
                        Store (I1MN, I1MX)
                        Add (I1MN, 0x80, Local0)
                        Store (Local0, I2MN)
                        Store (Local0, I2MX)
                        And (\_SB.PCI0.SMB0.NVSB, 0xFFFC, I3MN)
                        Store (I3MN, I3MX)
                        Add (I3MN, 0x80, Local0)
                        Store (Local0, I4MN)
                        Store (Local0, I4MX)
                        And (\_SB.PCI0.SMB0.ANLG, 0xFFFC, I5MN)
                        Store (I5MN, I5MX)
                        Add (I5MN, 0x80, Local0)
                        Store (Local0, I6MN)
                        Store (Local0, I6MX)
                        If (I1MN)
                        {
                            Store (IORT, Local0)
                        }
                        Else
                        {
                            Store (IODM, Local0)
                        }

                        Return (Local0)
                    }
                }

                OperationRegion (PMIF, SystemIO, 0x68, 0x08)
                Field (PMIF, ByteAcc, NoLock, Preserve)
                {
                    PMUD,   8, 
                            Offset (0x04), 
                    PMUC,   8, 
                            Offset (0x08)
                }

                Mutex (ELCK, 0x00)
                Method (WIBF, 0, NotSerialized)
                {
                    Store (0x0009FFFF, Local6)
                    Noop
                    Noop
                    Store (PMUC, Local2)
                    And (Local2, 0x22, Local2)
                    If (And (Local2, 0x20, Local3))
                    {
                        Return (0x01)
                    }

                    And (Local2, 0x02, Local2)
                    While (LAnd (LNotEqual (Local2, 0x00), LNotEqual (Local6, 0x00)))
                    {
                        Noop
                        Noop
                        Store (PMUC, Local2)
                        Decrement (Local6)
                        If (And (Local2, 0x20, Local3))
                        {
                            Return (0x01)
                        }

                        And (Local2, 0x02, Local2)
                    }

                    Return (0x00)
                }

                Method (WOBF, 0, NotSerialized)
                {
                    Store (0x009FFFFF, Local6)
                    Noop
                    Noop
                    Store (PMUC, Local3)
                    And (Local3, 0x21, Local3)
                    If (And (Local3, 0x20, Local2))
                    {
                        Return (0x01)
                    }

                    While (LAnd (LEqual (Local3, 0x00), LNotEqual (Local6, 0x00)))
                    {
                        Noop
                        Noop
                        Store (PMUC, Local3)
                        And (Local3, 0x21, Local3)
                        If (And (Local3, 0x20, Local2))
                        {
                            Return (0x01)
                        }

                        Decrement (Local6)
                    }

                    Return (0x00)
                }

                Method (RCMD, 2, NotSerialized)
                {
                    Store (Arg0, Local0)
                    Store (Arg1, Local1)
                    Store (Local0, PMUC)
                    If (WIBF ())
                    {
                        Return (0x01)
                    }

                    Store (Local1, PMUD)
                    If (WOBF ())
                    {
                        Return (0x01)
                    }

                    Return (0x00)
                }

                Method (WCMD, 2, NotSerialized)
                {
                    Store (Arg0, Local0)
                    Store (Arg1, Local1)
                    Store (Local0, PMUC)
                    If (WIBF ())
                    {
                        Return (0x01)
                    }

                    Store (Local1, PMUD)
                    If (WIBF ())
                    {
                        Return (0x01)
                    }

                    Return (0x00)
                }

                Method (PMRD, 1, NotSerialized)
                {
                    Acquire (ELCK, 0xFFFF)
                    Store (Zero, EDFG)
                    Store (0x14, RECT)
                    While (LAnd (LEqual (EDFG, 0x00), LNotEqual (RECT, 0x00)))
                    {
                        Store (Arg0, Local0)
                        Store (0x03E8, Local6)
                        Store (PMUC, Local1)
                        And (Local1, 0x13, Local1)
                        While (LAnd (LNotEqual (Local1, 0x00), LNotEqual (Local6, 0x00)))
                        {
                            Sleep (0x01)
                            Store (PMUC, Local1)
                            And (Local1, 0x13, Local1)
                            If (And (Local1, 0x01, Local2))
                            {
                                Store (PMUD, Local3)
                            }

                            Decrement (Local6)
                        }

                        While (RCMD (0x80, Local0))
                        {
                            Noop
                            Noop
                            Store (PMUC, Local5)
                            If (And (Local5, 0x01, Local2))
                            {
                                Store (PMUD, Local5)
                            }
                        }

                        Store (0x07D0, Local6)
                        Store (PMUC, Local1)
                        And (Local1, 0x10, Local1)
                        While (LAnd (LNotEqual (Local1, 0x00), LNotEqual (Local6, 0x00)))
                        {
                            Noop
                            Noop
                            Store (PMUC, Local1)
                            And (Local1, 0x10, Local1)
                            Decrement (Local6)
                        }

                        Store (PMUC, Local1)
                        And (Local1, 0x20, Local1)
                        If (LEqual (Local1, 0x00))
                        {
                            Store (One, EDFG)
                        }

                        Decrement (RECT)
                    }

                    Store (PMUD, Local4)
                    Release (ELCK)
                    Return (Local4)
                }

                Method (PMWT, 2, NotSerialized)
                {
                    Acquire (ELCK, 0xFFFF)
                    Store (Zero, EDFG)
                    Store (0x14, RECT)
                    While (LAnd (LEqual (EDFG, 0x00), LNotEqual (RECT, 0x00)))
                    {
                        Store (Arg0, Local0)
                        Store (0x03E8, Local6)
                        Store (PMUC, Local1)
                        And (Local1, 0x13, Local1)
                        While (LAnd (LNotEqual (Local1, 0x00), LNotEqual (Local6, 0x00)))
                        {
                            Sleep (0x01)
                            Store (PMUC, Local1)
                            And (Local1, 0x13, Local1)
                            Decrement (Local6)
                        }

                        While (WCMD (0x81, Local0))
                        {
                            Noop
                            Noop
                            Store (PMUC, Local5)
                            If (And (Local5, 0x01, Local2))
                            {
                                Store (PMUD, Local5)
                            }
                        }

                        Store (Arg1, PMUD)
                        Store (0x07D0, Local6)
                        Store (PMUC, Local1)
                        And (Local1, 0x12, Local1)
                        While (LAnd (LNotEqual (Local1, 0x00), LNotEqual (Local6, 0x00)))
                        {
                            Store (0x00, ED)
                            Noop
                            Noop
                            Store (0x00, ED)
                            Store (PMUC, Local1)
                            And (Local1, 0x12, Local1)
                            Decrement (Local6)
                        }

                        Store (PMUC, Local1)
                        And (Local1, 0x20, Local1)
                        If (LEqual (Local1, 0x00))
                        {
                            Store (One, EDFG)
                        }

                        Decrement (RECT)
                    }

                    Release (ELCK)
                }

                Method (PMMW, 2, NotSerialized)
                {
                    Store (Arg0, Local0)
                    Store (Arg1, Local1)
                    And (Local0, 0xFF, Local2)
                    And (Local0, 0xFF00, Local3)
                    ShiftRight (Local3, 0x08, Local3)
                    Add (Local2, Local3, Local4)
                    Add (Local4, 0xC1, Local4)
                    Add (Local4, Local1, Local7)
                    And (Local7, 0xFF, Local7)
                    PMWR (0x043F, Local7)
                    PMWR (Local0, Local1)
                }

                Method (PMWR, 2, NotSerialized)
                {
                    Acquire (ELCK, 0xFFFF)
                    Store (Zero, EDFG)
                    Store (0x14, RECT)
                    While (LAnd (LEqual (EDFG, 0x00), LNotEqual (RECT, 0x00)))
                    {
                        Store (0x03E8, Local6)
                        Store (PMUC, Local1)
                        And (Local1, 0x13, Local1)
                        While (LAnd (LNotEqual (Local1, 0x00), LNotEqual (Local6, 0x00)))
                        {
                            Sleep (0x01)
                            Store (PMUC, Local1)
                            And (Local1, 0x13, Local1)
                            Decrement (Local6)
                        }

                        Store (Arg0, Local0)
                        While (WCM2 (0xC1, Local0))
                        {
                            Store (0x00, ED)
                            Noop
                            Noop
                            Store (0x00, ED)
                            Store (PMUC, Local5)
                            If (And (Local5, 0x01, Local2))
                            {
                                Store (PMUD, Local5)
                            }
                        }

                        Store (Arg1, PMUD)
                        Store (0x07D0, Local6)
                        Store (PMUC, Local1)
                        And (Local1, 0x12, Local1)
                        While (LAnd (LNotEqual (Local1, 0x00), LNotEqual (Local6, 0x00)))
                        {
                            Store (0x00, ED)
                            Noop
                            Noop
                            Store (0x00, ED)
                            Store (PMUC, Local1)
                            And (Local1, 0x12, Local1)
                            Decrement (Local6)
                        }

                        Store (PMUC, Local1)
                        And (Local1, 0x20, Local1)
                        If (LEqual (Local1, 0x00))
                        {
                            Store (One, EDFG)
                        }

                        Decrement (RECT)
                    }

                    Release (ELCK)
                }

                Method (WCM2, 2, NotSerialized)
                {
                    Store (Arg0, Local0)
                    Store (Arg1, Local1)
                    Store (Arg1, Local2)
                    And (Local1, 0xFF, Local1)
                    And (Local2, 0xFF00, Local2)
                    ShiftRight (Local2, 0x08, Local2)
                    Store (Local0, PMUC)
                    If (WIBF ())
                    {
                        Return (0x01)
                    }

                    Store (Local2, PMUD)
                    If (WIBF ())
                    {
                        Return (0x01)
                    }

                    Store (Local1, PMUD)
                    If (WIBF ())
                    {
                        Return (0x01)
                    }

                    Return (0x00)
                }

                Name (EDFG, 0x00)
                Name (RECT, 0x00)
                OperationRegion (DELY, SystemIO, 0xED, 0x01)
                Field (DELY, ByteAcc, NoLock, Preserve)
                {
                    ED,     8
                }

                Method (SMST, 0, NotSerialized)
                {
                    Store (0x20, Local6)
                    Store (PMRD (0x70), Local0)
                    While (LAnd (LNotEqual (Local0, 0x00), LNotEqual (Local6, 0x00)))
                    {
                        Sleep (0x05)
                        Store (PMRD (0x70), Local0)
                        Decrement (Local6)
                    }

                    Store (0x20, Local6)
                    Store (PMRD (0x71), Local1)
                    While (LAnd (LNotEqual (Local1, 0x80), LNotEqual (Local6, 0x00)))
                    {
                        Sleep (0x05)
                        Store (PMRD (0x71), Local1)
                        Decrement (Local6)
                    }
                }

                Method (SMWT, 3, NotSerialized)
                {
                    Acquire (ELCK, 0xFFFF)
                    Store (0x06, Local6)
                    Store (Arg0, Local0)
                    Store (Arg1, Local1)
                    Store (Arg2, Local2)
                    While (LNotEqual (Local6, 0x00))
                    {
                        PMWT (0x71, 0x00)
                        PMWT (0x72, Local0)
                        PMWT (0x73, Local1)
                        PMWT (0x74, Local2)
                        PMWT (0x70, 0x06)
                        Sleep (0x32)
                        SMST ()
                        Decrement (Local6)
                    }

                    Release (ELCK)
                }

                Method (SMWD, 4, NotSerialized)
                {
                    Acquire (ELCK, 0xFFFF)
                    Store (0x06, Local6)
                    Store (Arg0, Local0)
                    Store (Arg1, Local1)
                    Store (Arg2, Local2)
                    Store (Arg3, Local3)
                    While (LNotEqual (Local6, 0x00))
                    {
                        PMWT (0x71, 0x00)
                        PMWT (0x72, Local0)
                        PMWT (0x73, Local1)
                        PMWT (0x74, Local2)
                        PMWT (0x75, Local3)
                        PMWT (0x70, 0x08)
                        SMST ()
                        Decrement (Local6)
                    }

                    Release (ELCK)
                }

                OperationRegion (NVSB, SystemIO, 0x1400, 0xFF)
                Field (NVSB, ByteAcc, NoLock, Preserve)
                {
                            Offset (0x2E), 
                    BCMD,   8
                }

                Device (KBC0)
                {
                    Name (_HID, EisaId ("PNP0303"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0060,             // Range Minimum
                            0x0060,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0064,             // Range Minimum
                            0x0064,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {1}
                    })
                }

                Device (MSE0)
                {
                    Name (_HID, EisaId ("PNP0F13"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {12}
                    })
                }

                Device (PIC0)
                {
                    Name (_HID, EisaId ("PNP0000"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0020,             // Range Minimum
                            0x0020,             // Range Maximum
                            0x04,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x00A0,             // Range Minimum
                            0x00A0,             // Range Maximum
                            0x04,               // Alignment
                            0x02,               // Length
                            )
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {2}
                    })
                }

                Device (DMA0)
                {
                    Name (_HID, EisaId ("PNP0200"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0000,             // Range Minimum
                            0x0000,             // Range Maximum
                            0x01,               // Alignment
                            0x09,               // Length
                            )
                        IO (Decode16,
                            0x000A,             // Range Minimum
                            0x000A,             // Range Maximum
                            0x01,               // Alignment
                            0x06,               // Length
                            )
                        IO (Decode16,
                            0x0081,             // Range Minimum
                            0x0081,             // Range Maximum
                            0x01,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0087,             // Range Minimum
                            0x0087,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0089,             // Range Minimum
                            0x0089,             // Range Maximum
                            0x01,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x008F,             // Range Minimum
                            0x008F,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x00C0,             // Range Minimum
                            0x00C0,             // Range Maximum
                            0x01,               // Alignment
                            0x12,               // Length
                            )
                        IO (Decode16,
                            0x00D4,             // Range Minimum
                            0x00D4,             // Range Maximum
                            0x01,               // Alignment
                            0x0C,               // Length
                            )
                        DMA (Compatibility, BusMaster, Transfer8, )
                            {4}
                    })
                }

                Device (SPK0)
                {
                    Name (_HID, EisaId ("PNP0800"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0061,             // Range Minimum
                            0x0061,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                    })
                }

                Device (MTH0)
                {
                    Name (_HID, EisaId ("PNP0C04"))
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x00F0,             // Range Minimum
                            0x00F0,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {13}
                    })
                }

                Device (PIT0)
                {
                    Name (_HID, EisaId ("PNP0100"))
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0040,             // Range Minimum
                            0x0040,             // Range Maximum
                            0x00,               // Alignment
                            0x04,               // Length
                            )
                    })
                    Name (BUF1, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0040,             // Range Minimum
                            0x0040,             // Range Maximum
                            0x00,               // Alignment
                            0x04,               // Length
                            )
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {0}
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (\_OSI ("Windows 2006"))
                        {
                            Return (BUF0)
                        }
                        Else
                        {
                            Return (BUF1)
                        }
                    }
                }

                Device (RTC0)
                {
                    Name (_HID, EisaId ("PNP0B00"))
                    Name (BUF2, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0070,             // Range Minimum
                            0x0070,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                    })
                    Name (BUF3, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0070,             // Range Minimum
                            0x0070,             // Range Maximum
                            0x00,               // Alignment
                            0x02,               // Length
                            )
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {8}
                    })
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (\_OSI ("Windows 2006"))
                        {
                            Return (BUF2)
                        }
                        Else
                        {
                            Return (BUF3)
                        }
                    }
                }

                Device (MMTM)
                {
                    Name (_HID, EisaId ("PNP0103"))
                    Name (BUF4, ResourceTemplate ()
                    {
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {0}
                        IRQ (Edge, ActiveHigh, Exclusive, )
                            {8}
                        Memory32Fixed (ReadOnly,
                            0x00000000,         // Address Base
                            0x00000400,         // Address Length
                            _Y08)
                    })
                    Name (BUF5, ResourceTemplate ()
                    {
                    })
                    Method (_STA, 0, NotSerialized)
                    {
                        If (\_OSI ("Windows 2006"))
                        {
                            Return (0x0F)
                        }

                        Return (0x00)
                    }

                    CreateDWordField (BUF4, \_SB.PCI0.LPC0.MMTM._Y08._BAS, MMBB)
                    Method (_CRS, 0, NotSerialized)
                    {
                        If (\_OSI ("Windows 2006"))
                        {
                            Store (\_SB.PCI0.LPC0.MTBA, MMBB)
                            Return (BUF4)
                        }
                        Else
                        {
                            Return (BUF5)
                        }
                    }
                }

                Mutex (PSMX, 0x00)
                Device (ACAD)
                {
                    Name (_HID, "ACPI0003")
                    Name (_PCL, Package (0x01)
                    {
                        \_SB
                    })
                    Name (ACFG, 0x00)
                    Method (_PSR, 0, NotSerialized)
                    {
                        Acquire (PSMX, 0xFFFF)
                        And (\_SB.PCI0.LPC0.PMRD (0xA0), 0x01, Local0)
                        Store (Local0, ACFG)
                        Release (PSMX)
                        Return (ACFG)
                    }

                    Method (_STA, 0, NotSerialized)
                    {
                        Return (0x0F)
                    }
                }

                Device (BAT0)
                {
                    Name (_HID, EisaId ("PNP0C0A"))
                    Name (_UID, 0x01)
                    Method (_STA, 0, NotSerialized)
                    {
                        Acquire (PSMX, 0xFFFF)
                        And (\_SB.PCI0.LPC0.PMRD (0xA1), 0x01, Local0)
                        Store (Local0, FSTA)
                        Release (PSMX)
                        If (LEqual (Local0, 0x00))
                        {
                            Return (0x0F)
                        }
                        Else
                        {
                            Return (0x1F)
                        }
                    }

                    Method (_BIF, 0, NotSerialized)
                    {
                        And (\_SB.PCI0.LPC0.PMRD (0xA1), 0x01, Local0)
                        If (Local0)
                        {
                            UPBI ()
                        }
                        Else
                        {
                            IVBI ()
                            IVBS ()
                        }

                        Store (Zero, FBIF)
                        Return (PBIF)
                    }

                    Method (_BST, 0, NotSerialized)
                    {
                        UPBS ()
                        And (\_SB.PCI0.LPC0.PMRD (0xA0), 0x01, ACON)
                        If (ACON)
                        {
                            And (\_SB.PCI0.LPC0.PMRD (0xE0), 0xFE, Local0)
                            \_SB.PCI0.LPC0.PMWT (0xE0, Local0)
                        }
                        Else
                        {
                            Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local0)
                            And (Local0, 0x10, Local1)
                            If (Local1)
                            {
                                Or (\_SB.PCI0.LPC0.PMRD (0xE0), 0x01, Local0)
                                \_SB.PCI0.LPC0.PMWT (0xE0, Local0)
                            }
                            Else
                            {
                                And (\_SB.PCI0.LPC0.PMRD (0xE0), 0xFE, Local0)
                                \_SB.PCI0.LPC0.PMWT (0xE0, Local0)
                            }
                        }

                        Return (PBST)
                    }

                    Method (IVBI, 0, NotSerialized)
                    {
                        Store (0xFFFFFFFF, Index (PBIF, 0x01))
                        Store (0xFFFFFFFF, Index (PBIF, 0x02))
                        Store (0xFFFFFFFF, Index (PBIF, 0x04))
                        Store ("Bad", Index (PBIF, 0x09))
                        Store ("Bad", Index (PBIF, 0x0A))
                        Store ("Bad", Index (PBIF, 0x0B))
                        Store ("Bad", Index (PBIF, 0x0C))
                        Store (One, FBIF)
                    }

                    Method (IVBS, 0, NotSerialized)
                    {
                        Store (Zero, Index (PBST, 0x00))
                        Store (0xFFFFFFFF, Index (PBST, 0x01))
                        Store (0xFFFFFFFF, Index (PBST, 0x02))
                        Store (0xFFFFFFFF, Index (PBST, 0x03))
                        Store (One, \_SB.PCI0.LPC0.BAT0.FSTA)
                    }

                    Method (UPBI, 0, NotSerialized)
                    {
                        Acquire (PSMX, 0xFFFF)
                        Store (\_SB.PCI0.LPC0.PMRD (0x00), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x01), Local1)
                        Multiply (Local1, 0x0100, Local2)
                        Or (Local0, Local2, Local3)
                        Store (Local3, Index (PBIF, 0x00))
                        Store (\_SB.PCI0.LPC0.PMRD (0x02), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x03), Local1)
                        Store (\_SB.PCI0.LPC0.PMRD (0x49), Local2)
                        Multiply (Local1, 0x0100, Local3)
                        Multiply (Local2, 0x00010000, Local4)
                        Or (Local3, Local0, Local5)
                        Or (Local4, Local5, Local6)
                        Store (Local6, Index (PBIF, 0x01))
                        Store (\_SB.PCI0.LPC0.PMRD (0x04), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x05), Local1)
                        Store (\_SB.PCI0.LPC0.PMRD (0x4A), Local2)
                        Multiply (Local1, 0x0100, Local3)
                        Multiply (Local2, 0x00010000, Local4)
                        Or (Local3, Local0, Local5)
                        Or (Local4, Local5, Local6)
                        Store (Local6, Index (PBIF, 0x02))
                        Store (\_SB.PCI0.LPC0.PMRD (0x06), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x07), Local1)
                        Multiply (Local1, 0x0100, Local2)
                        Or (Local2, Local0, Local3)
                        Store (Local3, Index (PBIF, 0x03))
                        Store (\_SB.PCI0.LPC0.PMRD (0x08), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x09), Local1)
                        Multiply (Local1, 0x0100, Local2)
                        Or (Local2, Local0, Local3)
                        Store (Local3, Index (PBIF, 0x04))
                        Divide (Local6, Local3, , Local7)
                        Store (0x026A, Index (PBIF, 0x05))
                        Store (0x0135, Index (PBIF, 0x05))
                        Store (\_SB.PCI0.LPC0.PMRD (0x0E), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x0F), Local1)
                        Multiply (Local1, 0x0100, Local2)
                        Or (Local2, Local0, Local3)
                        Store (Local3, Index (PBIF, 0x07))
                        Store (\_SB.PCI0.LPC0.PMRD (0x10), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x11), Local1)
                        Multiply (Local1, 0x0100, Local2)
                        Or (Local2, Local0, Local3)
                        Store (Local3, Index (PBIF, 0x08))
                        If (LEqual (\_SB.PCI0.LPC0.PMRD (0x18), 0x07))
                        {
                            Store ("CEX-XTB70SN6", Index (PBIF, 0x09))
                            Store ("CEX ", Index (PBIF, 0x0C))
                        }
                        Else
                        {
                            Store ("DPK-XTB70SY6", Index (PBIF, 0x09))
                            Store ("DPK ", Index (PBIF, 0x0C))
                        }

                        Store ("Lion", Index (PBIF, 0x0B))
                        Release (PSMX)
                        Return (PBIF)
                    }

                    Method (UPBS, 0, NotSerialized)
                    {
                        Acquire (PSMX, 0xFFFF)
                        Store (\_SB.PCI0.LPC0.PMRD (0x1A), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x1B), Local1)
                        Multiply (Local1, 0x0100, Local2)
                        Or (Local2, Local0, Local3)
                        Store (Local3, Index (PBST, 0x00))
                        Store (\_SB.PCI0.LPC0.PMRD (0x1C), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x1D), Local1)
                        Multiply (Local1, 0x0100, Local2)
                        Or (Local2, Local0, Local3)
                        Store (Local3, Index (PBST, 0x01))
                        Store (\_SB.PCI0.LPC0.PMRD (0x1E), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x1F), Local1)
                        Store (\_SB.PCI0.LPC0.PMRD (0x4B), Local2)
                        Multiply (Local1, 0x0100, Local3)
                        Multiply (Local2, 0x00010000, Local4)
                        Or (Local3, Local0, Local5)
                        Or (Local4, Local5, Local6)
                        Store (\_SB.PCI0.LPC0.PMRD (0x10), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x11), Local1)
                        Multiply (Local1, 0x0100, Local2)
                        Or (Local2, Local0, Local3)
                        Multiply (Local3, 0x02, Local3)
                        Divide (Local6, Local3, Local0, Local6)
                        Multiply (Local6, Local3, Local6)
                        Store (Local6, Index (PBST, 0x02))
                        Store (\_SB.PCI0.LPC0.PMRD (0x20), Local0)
                        Store (\_SB.PCI0.LPC0.PMRD (0x21), Local1)
                        Multiply (Local1, 0x0100, Local2)
                        Or (Local2, Local0, Local3)
                        Store (Local3, Index (PBST, 0x03))
                        Release (PSMX)
                        Return (PBST)
                    }

                    Method (_BTP, 1, NotSerialized)
                    {
                        Acquire (PSMX, 0xFFFF)
                        Store (\_SB.PCI0.LPC0.PMRD (0xB2), Local0)
                        And (Local0, 0x7F, Local0)
                        \_SB.PCI0.LPC0.PMWT (0xB2, Local0)
                        Store (Arg0, Local0)
                        Store (Local0, Local6)
                        And (Local0, 0xFF, Local1)
                        \_SB.PCI0.LPC0.PMWT (0x22, Local1)
                        Store (Local6, Local0)
                        And (Local0, 0xFF00, Local1)
                        ShiftRight (Local1, 0x08, Local2)
                        \_SB.PCI0.LPC0.PMWT (0x23, Local2)
                        Store (Local6, Local0)
                        And (Local0, 0x00FF0000, Local1)
                        ShiftRight (Local1, 0x10, Local2)
                        \_SB.PCI0.LPC0.PMWT (0x4C, Local2)
                        Store (\_SB.PCI0.LPC0.PMRD (0xF1), Local3)
                        If (And (Local3, 0x80, Local3))
                        {
                            Store (\_SB.PCI0.LPC0.PMRD (0xA1), Local4)
                            \_SB.PCI0.LPC0.PMWT (0xF1, Local4)
                        }

                        Store (\_SB.PCI0.LPC0.PMRD (0xB2), Local0)
                        Or (Local0, 0x80, Local0)
                        \_SB.PCI0.LPC0.PMWT (0xB2, Local0)
                        Release (PSMX)
                    }

                    Name (_PCL, Package (0x01)
                    {
                        \_SB
                    })
                    Name (FBIF, 0x01)
                    Name (FSTA, 0x01)
                    Name (GGFG, 0x00)
                    Name (PBIF, Package (0x0D)
                    {
                        0x01, 
                        0x78, 
                        0x64, 
                        0x01, 
                        0x2580, 
                        0x05, 
                        0x05, 
                        0x01, 
                        0x01, 
                        "", 
                        "", 
                        "", 
                        ""
                    })
                    Name (PBST, Package (0x04)
                    {
                        0x01, 
                        0x78, 
                        0x64, 
                        0x2580
                    })
                    Name (PSTA, 0x1F)
                }

                Device (SYS0)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, 0x01)
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0010,             // Range Minimum
                            0x0010,             // Range Maximum
                            0x01,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0022,             // Range Minimum
                            0x0022,             // Range Maximum
                            0x01,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x0044,             // Range Minimum
                            0x0044,             // Range Maximum
                            0x01,               // Alignment
                            0x1C,               // Length
                            )
                        IO (Decode16,
                            0x0063,             // Range Minimum
                            0x0063,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0065,             // Range Minimum
                            0x0065,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0067,             // Range Minimum
                            0x0067,             // Range Maximum
                            0x01,               // Alignment
                            0x09,               // Length
                            )
                        IO (Decode16,
                            0x0072,             // Range Minimum
                            0x0072,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x0074,             // Range Minimum
                            0x0074,             // Range Maximum
                            0x01,               // Alignment
                            0x0C,               // Length
                            )
                        IO (Decode16,
                            0x0080,             // Range Minimum
                            0x0080,             // Range Maximum
                            0x00,               // Alignment
                            0x01,               // Length
                            )
                        IO (Decode16,
                            0x0091,             // Range Minimum
                            0x0091,             // Range Maximum
                            0x01,               // Alignment
                            0x03,               // Length
                            )
                        IO (Decode16,
                            0x0097,             // Range Minimum
                            0x0097,             // Range Maximum
                            0x01,               // Alignment
                            0x09,               // Length
                            )
                        IO (Decode16,
                            0x00A2,             // Range Minimum
                            0x00A2,             // Range Maximum
                            0x01,               // Alignment
                            0x1E,               // Length
                            )
                        IO (Decode16,
                            0x00E0,             // Range Minimum
                            0x00E0,             // Range Maximum
                            0x01,               // Alignment
                            0x10,               // Length
                            )
                        IO (Decode16,
                            0x0360,             // Range Minimum
                            0x0360,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                        IO (Decode16,
                            0x04D0,             // Range Minimum
                            0x04D0,             // Range Maximum
                            0x01,               // Alignment
                            0x02,               // Length
                            )
                    })
                }
            }

            Device (SMB0)
            {
                Name (_ADR, 0x000A0001)
                OperationRegion (SMCF, PCI_Config, 0x48, 0x04)
                Field (SMCF, AnyAcc, NoLock, Preserve)
                {
                    SB48,   4
                }

                OperationRegion (SBA0, PCI_Config, 0x20, 0x04)
                Field (SBA0, AnyAcc, NoLock, Preserve)
                {
                    SB20,   16
                }

                OperationRegion (SBA1, PCI_Config, 0x24, 0x04)
                Field (SBA1, AnyAcc, NoLock, Preserve)
                {
                    SB24,   16
                }

                OperationRegion (SBA2, PCI_Config, 0x7C, 0x04)
                Field (SBA2, AnyAcc, NoLock, Preserve)
                {
                    SB7C,   16
                }

                OperationRegion (SM74, PCI_Config, 0x74, 0x04)
                Field (SM74, AnyAcc, NoLock, Preserve)
                {
                    SMUB,   32
                }

                OperationRegion (P60, PCI_Config, 0x60, 0x02)
                Field (P60, AnyAcc, NoLock, Preserve)
                {
                    PMBR,   16
                }

                OperationRegion (P64, PCI_Config, 0x64, 0x02)
                Field (P64, AnyAcc, NoLock, Preserve)
                {
                    NVSB,   16
                }

                OperationRegion (P68, PCI_Config, 0x68, 0x02)
                Field (P68, AnyAcc, NoLock, Preserve)
                {
                    ANLG,   16
                }
            }

            Device (USB0)
            {
                Name (_ADR, 0x000B0000)
                Name (_PRW, Package (0x02)
                {
                    0x0D, 
                    0x03
                })
            }

            Device (USB2)
            {
                Name (_ADR, 0x000B0001)
                Device (HUB0)
                {
                    Name (_ADR, 0x00)
                    Device (PRT3)
                    {
                        Name (_ADR, 0x03)
                        Method (_RMV, 0, NotSerialized)
                        {
                            Return (0x00)
                        }
                    }
                }

                Name (_PRW, Package (0x02)
                {
                    0x05, 
                    0x03
                })
            }

            Device (MAC0)
            {
                Name (_ADR, 0x00140000)
                Name (_PRW, Package (0x02)
                {
                    0x0B, 
                    0x03
                })
            }

            Device (AZA0)
            {
                Name (_ADR, 0x00100001)
                Name (_PRW, Package (0x02)
                {
                    0x15, 
                    0x03
                })
            }

            Device (P2P0)
            {
                Name (_ADR, 0x00100000)
                Name (_UID, 0x02)
                OperationRegion (A080, PCI_Config, 0x19, 0x01)
                Field (A080, ByteAcc, NoLock, Preserve)
                {
                    SECB,   8
                }

                Method (_BBN, 0, NotSerialized)
                {
                    Return (SECB)
                }

                Method (_STA, 0, NotSerialized)
                {
                    Return (0x0F)
                }

                Name (_PRT, Package (0x01)
                {
                    Package (0x04)
                    {
                        0x0006FFFF, 
                        0x00, 
                        \_SB.PCI0.LNK1, 
                        0x00
                    }
                })
            }

            Name (NATA, Package (0x01)
            {
                0x000D0000
            })
            Scope (\_SB.PCI0)
            {
                Device (NVRB)
                {
                    Name (_HID, "NVRAIDBUS")
                    Name (FNVR, 0xFF)
                    Method (_DIS, 0, NotSerialized)
                    {
                        Store (0x00, FNVR)
                    }

                    Method (_STA, 0, NotSerialized)
                    {
                        If (LEqual (\_SB.R_ST, 0x01))
                        {
                            If (LEqual (FNVR, 0xFF))
                            {
                                Return (0x0F)
                            }
                            Else
                            {
                                Return (0x0D)
                            }
                        }
                        Else
                        {
                            Return (0x00)
                        }
                    }

                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x04D2,             // Range Minimum
                            0x04D2,             // Range Maximum
                            0x01,               // Alignment
                            0x01,               // Length
                            )
                    })
                    Method (_SRS, 1, NotSerialized)
                    {
                        Store (0xFF, FNVR)
                    }
                }
            }

            Device (IDE0)
            {
                Name (SID4, 0x00)
                Name (SID5, 0x00)
                Name (SFLG, 0x00)
                Name (SID0, 0x00)
                Name (SID1, 0x00)
                Name (SID2, 0x00)
                Name (SID3, 0x00)
                Name (_ADR, 0x000D0000)
                OperationRegion (A090, PCI_Config, 0x50, 0x18)
                Field (A090, DWordAcc, NoLock, Preserve)
                {
                    ID20,   16, 
                            Offset (0x08), 
                    IDTS,   16, 
                    IDTP,   16, 
                    ID22,   32, 
                    UMSS,   16, 
                    UMSP,   16
                }

                Name (IDEP, Buffer (0x14) {})
                Name (IDES, Buffer (0x14) {})
                Method (GTM, 1, NotSerialized)
                {
                    If (LEqual (Arg0, 0x00))
                    {
                        Store (IDTP, Local0)
                        Store (UMSP, Local1)
                        Store (IDEP, Local2)
                    }
                    Else
                    {
                        Store (IDTS, Local0)
                        Store (UMSS, Local1)
                        Store (IDES, Local2)
                    }

                    CreateDWordField (Local2, 0x00, PIO0)
                    CreateDWordField (Local2, 0x04, DMA0)
                    CreateDWordField (Local2, 0x08, PIO1)
                    CreateDWordField (Local2, 0x0C, DMA1)
                    CreateDWordField (Local2, 0x10, FLAG)
                    Store (0x10, FLAG)
                    And (Local0, 0x0F00, Local3)
                    And (Local0, 0xF000, Local4)
                    ShiftRight (Local3, 0x08, Local3)
                    ShiftRight (Local4, 0x0C, Local4)
                    Add (Local3, Local4, Local3)
                    Multiply (Add (Local3, 0x02), 0x1E, PIO0)
                    If (LLessEqual (PIO0, 0xB4))
                    {
                        Or (FLAG, 0x02, FLAG)
                    }

                    If (And (Local1, 0x4000))
                    {
                        Or (FLAG, 0x01, FLAG)
                        And (Local1, 0x0700, Local3)
                        ShiftRight (Local3, 0x08, Local3)
                        Store (U2T (Local3), DMA0)
                    }
                    Else
                    {
                        Store (PIO0, DMA0)
                    }

                    And (Local0, 0x0F, Local3)
                    And (Local0, 0xF0, Local4)
                    ShiftRight (Local4, 0x04, Local4)
                    Add (Local3, Local4, Local3)
                    Multiply (Add (Local3, 0x02), 0x1E, PIO1)
                    If (LLessEqual (PIO1, 0xB4))
                    {
                        Or (FLAG, 0x08, FLAG)
                    }

                    If (And (Local1, 0x40))
                    {
                        Or (FLAG, 0x04, FLAG)
                        And (Local1, 0x07, Local3)
                        Store (U2T (Local3), DMA1)
                    }
                    Else
                    {
                        Store (PIO1, DMA1)
                    }

                    If (LEqual (Arg0, 0x00))
                    {
                        Store (Local2, IDEP)
                        Return (IDEP)
                    }
                    Else
                    {
                        Store (Local2, IDES)
                        Return (IDES)
                    }
                }

                Method (U2T, 1, NotSerialized)
                {
                    If (LEqual (Arg0, 0x00))
                    {
                        Return (0x3C)
                    }

                    If (LEqual (Arg0, 0x01))
                    {
                        Return (0x5A)
                    }

                    If (LEqual (Arg0, 0x02))
                    {
                        Return (0x78)
                    }

                    If (LEqual (Arg0, 0x03))
                    {
                        Return (0x96)
                    }

                    If (LEqual (Arg0, 0x04))
                    {
                        Return (0x2D)
                    }

                    If (LEqual (Arg0, 0x05))
                    {
                        Return (0x1E)
                    }

                    If (LEqual (Arg0, 0x06))
                    {
                        Return (0x14)
                    }

                    Return (0x0F)
                }

                Method (T2U, 1, NotSerialized)
                {
                    If (LGreater (Arg0, 0x78))
                    {
                        Return (0x03)
                    }

                    If (LGreater (Arg0, 0x5A))
                    {
                        Return (0x02)
                    }

                    If (LGreater (Arg0, 0x3C))
                    {
                        Return (0x01)
                    }

                    If (LGreater (Arg0, 0x2D))
                    {
                        Return (0x00)
                    }

                    If (LGreater (Arg0, 0x1E))
                    {
                        Return (0x04)
                    }

                    If (LGreater (Arg0, 0x14))
                    {
                        Return (0x05)
                    }

                    If (LGreater (Arg0, 0x0F))
                    {
                        Return (0x06)
                    }

                    Return (0x07)
                }

                Method (T2D, 1, NotSerialized)
                {
                    If (LGreater (Arg0, 0x01E0))
                    {
                        Return (0xA8)
                    }

                    If (LGreater (Arg0, 0x0186))
                    {
                        Return (0x77)
                    }

                    If (LGreater (Arg0, 0xF0))
                    {
                        Return (0x47)
                    }

                    If (LGreater (Arg0, 0xB4))
                    {
                        Return (0x33)
                    }

                    If (LGreater (Arg0, 0x96))
                    {
                        Return (0x22)
                    }

                    If (LGreater (Arg0, 0x78))
                    {
                        Return (0x21)
                    }

                    Return (0x20)
                }

                Method (STM, 4, NotSerialized)
                {
                    If (SX)
                    {
                        Store (SID0, ID20)
                        Store (SID1, IDTS)
                        Store (SID2, IDTP)
                        Store (SID3, ID22)
                        Store (SID4, UMSS)
                        Store (SID5, UMSP)
                    }
                    Else
                    {
                        Store (ID20, SID0)
                        Store (IDTS, SID1)
                        Store (IDTP, SID2)
                        Store (ID22, SID3)
                        Store (UMSS, SID4)
                        Store (UMSP, SID5)
                    }

                    Store (0x00, SX)
                    CreateDWordField (Arg0, 0x00, PIO0)
                    CreateDWordField (Arg0, 0x04, DMA0)
                    CreateDWordField (Arg0, 0x08, PIO1)
                    CreateDWordField (Arg0, 0x0C, DMA1)
                    CreateDWordField (Arg0, 0x10, FLAG)
                    If (LEqual (Arg3, 0x00))
                    {
                        Store (SID2, Local0)
                        Store (SID5, Local1)
                    }
                    Else
                    {
                        Store (SID1, Local0)
                        Store (SID4, Local1)
                    }

                    If (LNotEqual (PIO0, 0xFFFFFFFF))
                    {
                        And (Local0, 0xFF, Local0)
                        ShiftLeft (T2D (PIO0), 0x08, Local2)
                        Or (Local0, Local2, Local0)
                    }

                    If (LNotEqual (PIO1, 0xFFFFFFFF))
                    {
                        And (Local0, 0xFF00, Local0)
                        Or (Local0, T2D (PIO1), Local0)
                    }

                    If (And (FLAG, 0x01))
                    {
                        And (Local1, 0xFF, Local1)
                        ShiftLeft (T2U (DMA0), 0x08, Local2)
                        Or (0xC000, Local2, Local2)
                        Or (Local2, Local1, Local1)
                    }
                    Else
                    {
                        If (LNotEqual (DMA0, 0xFFFFFFFF))
                        {
                            And (Local0, 0xFF, Local0)
                            ShiftLeft (T2D (DMA0), 0x08, Local2)
                            Or (Local0, Local2, Local0)
                        }
                    }

                    If (And (FLAG, 0x04))
                    {
                        And (Local1, 0xFF00, Local1)
                        Or (0xC0, T2U (DMA1), Local2)
                        Or (Local2, Local1, Local1)
                    }
                    Else
                    {
                        If (LNotEqual (DMA1, 0xFFFFFFFF))
                        {
                            And (Local0, 0xFF00, Local0)
                            Or (Local0, T2D (DMA1), Local0)
                        }
                    }

                    If (LEqual (Arg3, 0x00))
                    {
                        Store (Local0, IDTP)
                        Store (Local1, UMSP)
                    }
                    Else
                    {
                        Store (Local0, IDTS)
                        Store (Local1, UMSS)
                    }
                }

                Method (GTF, 2, NotSerialized)
                {
                    Store (Buffer (0x07)
                        {
                            0x03, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF
                        }, Local0)
                    CreateByteField (Local0, 0x01, MODE)
                    CreateByteField (Local0, 0x05, DRIV)
                    Store (Arg1, DRIV)
                    If (LEqual (Arg0, 0x00))
                    {
                        Store (IDEP, Local1)
                    }
                    Else
                    {
                        Store (IDES, Local1)
                    }

                    CreateDWordField (Local1, 0x00, PIO0)
                    CreateDWordField (Local1, 0x04, DMA0)
                    CreateDWordField (Local1, 0x08, PIO1)
                    CreateDWordField (Local1, 0x0C, DMA1)
                    CreateDWordField (Local1, 0x10, FLGX)
                    If (LEqual (Arg1, 0xA0))
                    {
                        Store (PIO0, Local2)
                        Store (DMA0, Local3)
                        And (FLGX, 0x01, FLGX)
                    }
                    Else
                    {
                        Store (PIO1, Local2)
                        Store (DMA1, Local3)
                        And (FLGX, 0x04, FLGX)
                    }

                    Store (FLGX, Local1)
                    If (LGreater (Local2, 0x0186))
                    {
                        Store (0x00, Local2)
                    }
                    Else
                    {
                        If (LGreater (Local2, 0xF0))
                        {
                            Store (0x01, Local2)
                        }
                        Else
                        {
                            If (LGreater (Local2, 0xB4))
                            {
                                Store (0x02, Local2)
                            }
                            Else
                            {
                                If (LGreater (Local2, 0x78))
                                {
                                    Store (0x03, Local2)
                                }
                                Else
                                {
                                    Store (0x04, Local2)
                                }
                            }
                        }
                    }

                    Or (0x08, Local2, MODE)
                    Store (Local0, Local2)
                    If (FLGX)
                    {
                        If (LGreater (Local3, 0x5A))
                        {
                            Store (0x00, Local3)
                        }
                        Else
                        {
                            If (LGreater (Local3, 0x3C))
                            {
                                Store (0x01, Local3)
                            }
                            Else
                            {
                                If (LGreater (Local3, 0x2D))
                                {
                                    Store (0x02, Local3)
                                }
                                Else
                                {
                                    If (LGreater (Local3, 0x1E))
                                    {
                                        Store (0x03, Local3)
                                    }
                                    Else
                                    {
                                        If (LGreater (Local3, 0x14))
                                        {
                                            Store (0x04, Local3)
                                        }
                                        Else
                                        {
                                            If (LGreater (Local3, 0x0F))
                                            {
                                                Store (0x05, Local3)
                                            }
                                            Else
                                            {
                                                Store (0x06, Local3)
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        Or (0x40, Local3, MODE)
                    }
                    Else
                    {
                        If (LEqual (Local3, 0xFFFFFFFF))
                        {
                            Return (Local0)
                        }
                        Else
                        {
                            If (LGreater (Local3, 0x96))
                            {
                                Store (0x00, Local3)
                            }
                            Else
                            {
                                If (LGreater (Local3, 0x78))
                                {
                                    Store (0x01, Local3)
                                }
                                Else
                                {
                                    Store (0x02, Local3)
                                }
                            }

                            Or (0x20, Local3, MODE)
                        }
                    }

                    Concatenate (Local0, Local2, Local1)
                    Return (Local1)
                }

                Device (PRI0)
                {
                    Name (_ADR, 0x00)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (GTM (0x00))
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        STM (Arg0, Arg1, Arg2, 0x00)
                    }

                    Device (MAST)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (GTF (0x00, 0xA0))
                        }
                    }

                    Device (SLAV)
                    {
                        Name (_ADR, 0x01)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (GTF (0x00, 0xB0))
                        }
                    }
                }

                Device (SEC0)
                {
                    Name (_ADR, 0x01)
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (GTM (0x01))
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        STM (Arg0, Arg1, Arg2, 0x01)
                    }

                    Device (MAST)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (GTF (0x01, 0xA0))
                        }
                    }

                    Device (SLAV)
                    {
                        Name (_ADR, 0x01)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Return (GTF (0x01, 0xB0))
                        }
                    }
                }

                Method (DRMP, 0, NotSerialized)
                {
                    Return (\_SB.R_P0)
                }
            }

            Device (SAT0)
            {
                Name (_ADR, 0x000E0000)
                Device (PRI0)
                {
                    Name (_ADR, 0x00)
                    Name (SPTM, Buffer (0x14)
                    {
                        /* 0000 */    0x78, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x00, 
                        /* 0008 */    0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
                        /* 0010 */    0x13, 0x00, 0x00, 0x00
                    })
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (SPTM)
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, SPTM)
                    }

                    Device (MAST)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Store (Buffer (0x07)
                                {
                                    0x03, 0x46, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                }, Local0)
                            Return (Local0)
                        }
                    }

                    Method (_RMV, 0, NotSerialized)
                    {
                        Return (0x00)
                    }
                }

                Device (SEC0)
                {
                    Name (_ADR, 0x01)
                    Name (SSTM, Buffer (0x14)
                    {
                        /* 0000 */    0x78, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x00, 
                        /* 0008 */    0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
                        /* 0010 */    0x13, 0x00, 0x00, 0x00
                    })
                    Method (_GTM, 0, NotSerialized)
                    {
                        Return (SSTM)
                    }

                    Method (_STM, 3, NotSerialized)
                    {
                        Store (Arg0, SSTM)
                    }

                    Device (MAST)
                    {
                        Name (_ADR, 0x00)
                        Method (_GTF, 0, NotSerialized)
                        {
                            Store (Buffer (0x07)
                                {
                                    0x03, 0x46, 0x00, 0x00, 0x00, 0xA0, 0xEF
                                }, Local0)
                            Return (Local0)
                        }
                    }
                }

                Method (DRMP, 0, NotSerialized)
                {
                    Return (\_SB.R_S0)
                }
            }

            Device (XVR0)
            {
                Name (_ADR, 0x00040000)
                Name (_UID, 0x03)
                OperationRegion (A1E0, PCI_Config, 0x19, 0x01)
                Field (A1E0, ByteAcc, NoLock, Preserve)
                {
                    SECB,   8
                }

                Method (_BBN, 0, NotSerialized)
                {
                    Return (SECB)
                }

                Method (_STA, 0, NotSerialized)
                {
                    Return (0x0F)
                }

                Name (_PRT, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        0x00, 
                        \_SB.PCI0.LK1E, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x01, 
                        \_SB.PCI0.LK2E, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        \_SB.PCI0.LK3E, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        \_SB.PCI0.LK4E, 
                        0x00
                    }
                })
                Device (VGA)
                {
                    Name (_ADR, 0x00)
                    Method (_DOD, 0, NotSerialized)
                    {
                        Return (Package (0x04)
                        {
                            0x00010100, 
                            0x00010200, 
                            0x00010110, 
                            0x00010120
                        })
                    }

                    Device (CRT)
                    {
                        Name (_ADR, 0x0100)
                        Method (_DCS, 0, NotSerialized)
                        {
                            If (LEqual (And (\_SB.PCI0.LPC0.PMRD (0xF1), 0x02), 0x02))
                            {
                                Return (0x1F)
                            }
                            Else
                            {
                                Return (0x1D)
                            }
                        }

                        Method (_DGS, 0, NotSerialized)
                        {
                            If (LEqual (And (\_SB.PCI0.LPC0.PMRD (0xF2), 0x02), 0x02))
                            {
                                Return (0x01)
                            }
                            Else
                            {
                                Return (0x00)
                            }
                        }

                        Method (_DSS, 1, NotSerialized)
                        {
                        }
                    }

                    Device (LCD)
                    {
                        Name (_ADR, 0x0110)
                        Method (_DCS, 0, NotSerialized)
                        {
                            If (LEqual (And (\_SB.PCI0.LPC0.PMRD (0xF1), 0x01), 0x01))
                            {
                                Return (0x1F)
                            }
                            Else
                            {
                                Return (0x1D)
                            }
                        }

                        Method (_DGS, 0, NotSerialized)
                        {
                            If (LEqual (And (\_SB.PCI0.LPC0.PMRD (0xF2), 0x01), 0x01))
                            {
                                Return (0x01)
                            }
                            Else
                            {
                                Return (0x00)
                            }
                        }

                        Method (_DSS, 1, NotSerialized)
                        {
                        }

                        Method (_BCL, 0, NotSerialized)
                        {
                            Return (Package (0x0A)
                            {
                                0x07, 
                                0x00, 
                                0x00, 
                                0x01, 
                                0x02, 
                                0x03, 
                                0x04, 
                                0x05, 
                                0x06, 
                                0x07
                            })
                        }

                        Method (_BCM, 1, NotSerialized)
                        {
                        }
                    }

                    Device (TV)
                    {
                        Name (_ADR, 0x0200)
                        Method (_DCS, 0, NotSerialized)
                        {
                            If (LEqual (And (\_SB.PCI0.LPC0.PMRD (0xF1), 0x04), 0x04))
                            {
                                Return (0x1F)
                            }
                            Else
                            {
                                Return (0x1D)
                            }
                        }

                        Method (_DGS, 0, NotSerialized)
                        {
                            If (LEqual (And (\_SB.PCI0.LPC0.PMRD (0xF2), 0x04), 0x04))
                            {
                                Return (0x01)
                            }
                            Else
                            {
                                Return (0x00)
                            }
                        }

                        Method (_DSS, 1, NotSerialized)
                        {
                        }
                    }

                    Device (DVI)
                    {
                        Name (_ADR, 0x0120)
                        Method (_DCS, 0, NotSerialized)
                        {
                            If (LEqual (And (\_SB.PCI0.LPC0.PMRD (0xF1), 0x08), 0x08))
                            {
                                Return (0x1F)
                            }
                            Else
                            {
                                Return (0x1D)
                            }
                        }

                        Method (_DGS, 0, NotSerialized)
                        {
                            If (LEqual (And (\_SB.PCI0.LPC0.PMRD (0xF2), 0x08), 0x08))
                            {
                                Return (0x01)
                            }
                            Else
                            {
                                Return (0x00)
                            }
                        }

                        Method (_DSS, 1, NotSerialized)
                        {
                        }
                    }

                    Method (NVIF, 3, NotSerialized)
                    {
                        Store (Buffer (0x04) {}, Local0)
                        CreateDWordField (Local0, 0x00, STA0)
                        Store (Buffer (0x04) {}, Local1)
                        CreateDWordField (Local1, 0x00, DAT0)
                        Store (0x80000002, STA0)
                        Store (0x00, DAT0)
                        If (LEqual (Arg0, 0x01))
                        {
                            If (LEqual (Arg1, 0x00))
                            {
                                Store (0x00, STA0)
                                Store (0x01, DAT0)
                                Concatenate (Local0, Local1, Local0)
                            }

                            Return (Local0)
                        }

                        If (LEqual (Arg0, 0x09))
                        {
                            If (LEqual (Arg1, 0x00))
                            {
                                Store (0x00, STA0)
                                Concatenate (Local0, Local1, Local0)
                            }
                            Else
                            {
                                If (LEqual (Arg1, 0x01))
                                {
                                    Store (0x00, STA0)
                                    CreateDWordField (Arg2, 0x00, INDX)
                                    If (LEqual (INDX, 0x00))
                                    {
                                        Store (Buffer (0x0C)
                                            {
                                                /* 0000 */    0x00, 0x00, 0x64, 0x00, 0xC8, 0x00, 0x00, 0x00, 
                                                /* 0008 */    0x00, 0x00, 0xE8, 0x03
                                            }, Local1)
                                        Concatenate (Local0, Local1, Local0)
                                    }
                                }
                                Else
                                {
                                    If (LEqual (Arg1, 0x03))
                                    {
                                        Store (0x00, STA0)
                                        Store (Buffer (0x0A)
                                            {
                                                /* 0000 */    0x64, 0x14, 0x14, 0x23, 0x35, 0x3E, 0x45, 0x4E, 
                                                /* 0008 */    0x58, 0x64
                                            }, Local1)
                                        Concatenate (Local0, Local1, Local0)
                                    }
                                }
                            }

                            Return (Local0)
                        }
                    }
                }
            }

            Device (XVR1)
            {
                Name (_ADR, 0x00030000)
                Name (_UID, 0x04)
                OperationRegion (A1E1, PCI_Config, 0x19, 0x01)
                Field (A1E1, ByteAcc, NoLock, Preserve)
                {
                    SECB,   8
                }

                Method (_BBN, 0, NotSerialized)
                {
                    Return (SECB)
                }

                Method (_STA, 0, NotSerialized)
                {
                    Return (0x0F)
                }

                Name (_PRT, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        0x00, 
                        \_SB.PCI0.LK1E, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x01, 
                        \_SB.PCI0.LK2E, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        \_SB.PCI0.LK3E, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        \_SB.PCI0.LK4E, 
                        0x00
                    }
                })
                Device (X1S0)
                {
                    Name (_ADR, 0x00)
                }
            }

            Device (XVR2)
            {
                Name (_ADR, 0x00020000)
                Name (_UID, 0x05)
                OperationRegion (A1E2, PCI_Config, 0x19, 0x01)
                Field (A1E2, ByteAcc, NoLock, Preserve)
                {
                    SECB,   8
                }

                Method (_BBN, 0, NotSerialized)
                {
                    Return (SECB)
                }

                Method (_STA, 0, NotSerialized)
                {
                    Return (0x0F)
                }

                Name (_PRT, Package (0x04)
                {
                    Package (0x04)
                    {
                        0xFFFF, 
                        0x00, 
                        \_SB.PCI0.LK2E, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x01, 
                        \_SB.PCI0.LK3E, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x02, 
                        \_SB.PCI0.LK4E, 
                        0x00
                    }, 

                    Package (0x04)
                    {
                        0xFFFF, 
                        0x03, 
                        \_SB.PCI0.LK1E, 
                        0x00
                    }
                })
                Device (X2S0)
                {
                    Name (_ADR, 0x00)
                    Method (_EJ0, 0, NotSerialized)
                    {
                        Return (0x00)
                    }
                }
            }
        }

        Scope (\)
        {
            Name (PICF, 0x00)
            Method (_PIC, 1, NotSerialized)
            {
                Store (Arg0, PICF)
            }

            OperationRegion (\_SB.PCI0.LPC0.PIRQ, PCI_Config, 0x7C, 0x0C)
            Field (\_SB.PCI0.LPC0.PIRQ, AnyAcc, NoLock, Preserve)
            {
                INTW,   4, 
                INTX,   4, 
                INTY,   4, 
                INTZ,   4, 
                INTA,   4, 
                INTB,   4, 
                INTC,   4, 
                INTD,   4, 
                ISCI,   4, 
                ITCO,   4, 
                ISMB,   4, 
                IUS2,   4, 
                INTU,   4, 
                INTS,   4, 
                PSI1,   4, 
                PSI0,   4, 
                IUS0,   4, 
                IUS1,   4, 
                IMAC,   4, 
                IAZA,   4, 
                IACI,   4, 
                IMCI,   4, 
                IPID,   4, 
                ISID,   4
            }
        }

        Scope (\_SB.PCI0)
        {
            Name (BUFA, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, )
                    {5,7,9,10,11,14,15}
            })
            Name (BUFB, ResourceTemplate ()
            {
                IRQ (Level, ActiveLow, Shared, _Y09)
                    {}
            })
            CreateWordField (BUFB, \_SB.PCI0._Y09._INT, IRQV)
            Method (CRS, 1, Serialized)
            {
                If (Arg0)
                {
                    ShiftLeft (0x01, Arg0, IRQV)
                }
                Else
                {
                    Store (Zero, IRQV)
                }

                Return (BUFB)
            }

            Method (SRS, 1, Serialized)
            {
                CreateWordField (Arg0, 0x01, IRQ0)
                FindSetRightBit (IRQ0, Local0)
                Decrement (Local0)
                Return (Local0)
            }

            Name (BUFI, ResourceTemplate ()
            {
                Interrupt (ResourceConsumer, Level, ActiveLow, Shared, ,, )
                {
                    0x00000010,
                    0x00000011,
                    0x00000012,
                    0x00000013,
                    0x00000014,
                    0x00000015,
                    0x00000016,
                    0x00000017,
                }
            })
            Name (BUFF, ResourceTemplate ()
            {
                Interrupt (ResourceConsumer, Level, ActiveLow, Shared, ,, )
                {
                    0x00000005,
                    0x00000007,
                    0x0000000A,
                    0x0000000B,
                    0x0000000E,
                    0x0000000F,
                }
            })
            Method (CRSI, 1, Serialized)
            {
                Name (IRZ5, ResourceTemplate ()
                {
                    Interrupt (ResourceConsumer, Level, ActiveHigh, Shared, ,, _Y0A)
                    {
                        0x00000007,
                    }
                })
                CreateWordField (IRZ5, \_SB.PCI0.CRSI._Y0A._INT, INZ5)
                Store (Arg0, Local0)
                If (LEqual (Arg0, 0x03))
                {
                    Store (0x10, Local0)
                }

                If (LEqual (Arg0, 0x04))
                {
                    Store (0x11, Local0)
                }

                If (LEqual (Arg0, 0x06))
                {
                    Store (0x12, Local0)
                }

                If (LEqual (Arg0, 0x0C))
                {
                    Store (0x13, Local0)
                }

                If (LEqual (Arg0, 0x08))
                {
                    Store (0x14, Local0)
                }

                If (LEqual (Arg0, 0x0D))
                {
                    Store (0x15, Local0)
                }

                If (LEqual (Arg0, 0x02))
                {
                    Store (0x16, Local0)
                }

                If (LEqual (Arg0, 0x01))
                {
                    Store (0x17, Local0)
                }

                Store (Local0, INZ5)
                Return (IRZ5)
            }

            Method (SRSI, 1, Serialized)
            {
                CreateWordField (Arg0, 0x05, IRZ6)
                Store (IRZ6, Local0)
                If (LEqual (IRZ6, 0x10))
                {
                    Store (0x03, Local0)
                }

                If (LEqual (IRZ6, 0x11))
                {
                    Store (0x04, Local0)
                }

                If (LEqual (IRZ6, 0x12))
                {
                    Store (0x06, Local0)
                }

                If (LEqual (IRZ6, 0x13))
                {
                    Store (0x0C, Local0)
                }

                If (LEqual (IRZ6, 0x14))
                {
                    Store (0x08, Local0)
                }

                If (LEqual (IRZ6, 0x15))
                {
                    Store (0x0D, Local0)
                }

                If (LEqual (IRZ6, 0x16))
                {
                    Store (0x02, Local0)
                }

                If (LEqual (IRZ6, 0x17))
                {
                    Store (0x01, Local0)
                }

                Return (Local0)
            }

            Device (LNK1)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x01)
                Method (_STA, 0, NotSerialized)
                {
                    If (INTW)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, INTW)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFF)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (INTW))
                    }
                    Else
                    {
                        Return (CRSI (INTW))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), INTW)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), INTW)
                    }
                }
            }

            Device (LNK2)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x02)
                Method (_STA, 0, NotSerialized)
                {
                    If (INTX)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, INTX)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFF)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (INTX))
                    }
                    Else
                    {
                        Return (CRSI (INTX))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), INTX)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), INTX)
                    }
                }
            }

            Device (LNK3)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x03)
                Method (_STA, 0, NotSerialized)
                {
                    If (INTY)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, INTY)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFF)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (INTY))
                    }
                    Else
                    {
                        Return (CRSI (INTY))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), INTY)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), INTY)
                    }
                }
            }

            Device (LNK4)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x04)
                Method (_STA, 0, NotSerialized)
                {
                    If (INTZ)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, INTZ)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFF)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (INTZ))
                    }
                    Else
                    {
                        Return (CRSI (INTZ))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), INTZ)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), INTZ)
                    }
                }
            }

            Device (LK1E)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x05)
                Method (_STA, 0, NotSerialized)
                {
                    If (INTA)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, INTA)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (INTA))
                    }
                    Else
                    {
                        Return (CRSI (INTA))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), INTA)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), INTA)
                    }
                }
            }

            Device (LK2E)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x06)
                Method (_STA, 0, NotSerialized)
                {
                    If (INTB)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, INTB)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (INTB))
                    }
                    Else
                    {
                        Return (CRSI (INTB))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), INTB)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), INTB)
                    }
                }
            }

            Device (LK3E)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x07)
                Method (_STA, 0, NotSerialized)
                {
                    If (INTC)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, INTC)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (INTC))
                    }
                    Else
                    {
                        Return (CRSI (INTC))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), INTC)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), INTC)
                    }
                }
            }

            Device (LK4E)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x08)
                Method (_STA, 0, NotSerialized)
                {
                    If (INTD)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, INTD)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (INTD))
                    }
                    Else
                    {
                        Return (CRSI (INTD))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), INTD)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), INTD)
                    }
                }
            }

            Device (LSMB)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x09)
                Method (_STA, 0, NotSerialized)
                {
                    If (ISMB)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, ISMB)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (ISMB))
                    }
                    Else
                    {
                        Return (CRSI (ISMB))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), ISMB)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), ISMB)
                    }
                }
            }

            Device (LPMU)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x14)
                Method (_STA, 0, NotSerialized)
                {
                    If (INTS)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, INTS)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (INTS))
                    }
                    Else
                    {
                        Return (CRSI (INTS))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), INTS)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), INTS)
                    }
                }
            }

            Device (LUS0)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x0A)
                Method (_STA, 0, NotSerialized)
                {
                    If (IUS0)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, IUS0)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (IUS0))
                    }
                    Else
                    {
                        Return (CRSI (IUS0))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), IUS0)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), IUS0)
                    }
                }
            }

            Device (LUS2)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x0C)
                Method (_STA, 0, NotSerialized)
                {
                    If (IUS2)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, IUS2)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (IUS2))
                    }
                    Else
                    {
                        Return (CRSI (IUS2))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), IUS2)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), IUS2)
                    }
                }
            }

            Device (LMAC)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x0D)
                Method (_STA, 0, NotSerialized)
                {
                    If (IMAC)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, IMAC)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (IMAC))
                    }
                    Else
                    {
                        Return (CRSI (IMAC))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), IMAC)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), IMAC)
                    }
                }
            }

            Device (LAZA)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x0E)
                Method (_STA, 0, NotSerialized)
                {
                    If (IAZA)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, IAZA)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (IAZA))
                    }
                    Else
                    {
                        Return (CRSI (IAZA))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), IAZA)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), IAZA)
                    }
                }
            }

            Device (LPID)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x11)
                Method (_STA, 0, NotSerialized)
                {
                    If (IPID)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, IPID)
                    Store (0x00, ISID)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (IPID))
                    }
                    Else
                    {
                        Return (CRSI (IPID))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), IPID)
                        Store (SRS (Arg0), ISID)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), IPID)
                        Store (SRSI (Arg0), ISID)
                    }
                }
            }

            Device (LTID)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x12)
                Method (_STA, 0, NotSerialized)
                {
                    If (PSI0)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, PSI0)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (PSI0))
                    }
                    Else
                    {
                        Return (CRSI (PSI0))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), PSI0)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), PSI0)
                    }
                }
            }

            Device (LSI1)
            {
                Name (_HID, EisaId ("PNP0C0F"))
                Name (_UID, 0x13)
                Method (_STA, 0, NotSerialized)
                {
                    If (PSI1)
                    {
                        Return (0x0B)
                    }
                    Else
                    {
                        Return (0x09)
                    }
                }

                Method (_DIS, 0, NotSerialized)
                {
                    Store (0x00, PSI1)
                }

                Method (_PRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (BUFA)
                    }
                    Else
                    {
                        Return (BUFI)
                    }
                }

                Method (_CRS, 0, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Return (CRS (PSI1))
                    }
                    Else
                    {
                        Return (CRSI (PSI1))
                    }
                }

                Method (_SRS, 1, NotSerialized)
                {
                    If (LNot (PICF))
                    {
                        Store (SRS (Arg0), PSI1)
                    }
                    Else
                    {
                        Store (SRSI (Arg0), PSI1)
                    }
                }
            }
        }

        Device (LID)
        {
            Name (_HID, EisaId ("PNP0C0D"))
            Name (LIDF, 0x01)
            Method (_LID, 0, NotSerialized)
            {
                Return (LIDF)
            }

            Name (_PRW, Package (0x02)
            {
                0x12, 
                0x03
            })
        }

        Mutex (VSMX, 0x00)
        Method (Z004, 1, Serialized)
        {
            Acquire (VSMX, 0xFFFF)
            Store (Arg0, \_SB.PCI0.LPC0.BCMD)
            Release (VSMX)
        }
    }

    Scope (_TZ)
    {
        Mutex (TZ0, 0x00)
        Mutex (TZ1, 0x00)
        PowerResource (FN10, 0x00, 0x0000)
        {
            Method (_ON, 0, NotSerialized)
            {
                Or (\_SB.PCI0.LPC0.PMRD (0xFA), 0x03, Local0)
                \_SB.PCI0.LPC0.PMWT (0xFA, Local0)
                \_TZ.THRM.FANC ()
            }

            Method (_OFF, 0, NotSerialized)
            {
                Store (\_SB.PCI0.LPC0.PMRD (0xFA), Local0)
                And (Local0, Not (0x02), Local0)
                \_SB.PCI0.LPC0.PMWT (0xFA, Local0)
            }

            Method (_STA, 0, NotSerialized)
            {
                And (\_SB.PCI0.LPC0.PMRD (0xFA), 0x02, Local7)
                ShiftRight (Local7, 0x01, Local7)
                Return (Local7)
            }
        }

        PowerResource (FN11, 0x00, 0x0000)
        {
            Method (_ON, 0, NotSerialized)
            {
                Or (\_SB.PCI0.LPC0.PMRD (0xFA), 0x01, Local0)
                \_SB.PCI0.LPC0.PMWT (0xFA, Local0)
                \_TZ.THRM.FANC ()
            }

            Method (_OFF, 0, NotSerialized)
            {
                Store (\_SB.PCI0.LPC0.PMRD (0xFA), Local0)
                And (Local0, Not (0x03), Local0)
                \_SB.PCI0.LPC0.PMWT (0xFA, Local0)
                \_TZ.THRM.FANC ()
            }

            Method (_STA, 0, NotSerialized)
            {
                And (\_SB.PCI0.LPC0.PMRD (0xFA), 0x01, Local7)
                ShiftRight (Local7, 0x00, Local7)
                Return (Local7)
            }
        }

        Device (FN1)
        {
            Name (_HID, EisaId ("PNP0C0B"))
            Name (_UID, 0x01)
            Name (_PR0, Package (0x01)
            {
                FN10
            })
        }

        Device (FN2)
        {
            Name (_HID, EisaId ("PNP0C0B"))
            Name (_UID, 0x02)
            Name (_PR0, Package (0x01)
            {
                FN11
            })
        }

        ThermalZone (THRM)
        {
            Name (INIT, 0x00)
            Name (MODE, 0x00)
            Name (THRO, 0x00)
            Name (HILM, Package (0x04)
            {
                0x41, 
                0x49, 
                0x55, 
                0x69
            })
            Name (LOLM, Package (0x04)
            {
                0x00, 
                0x37, 
                0x44, 
                0x4E
            })
            Name (Z006, Package (0x04)
            {
                0x46, 
                0x55, 
                0x55, 
                0x69
            })
            Name (Z007, Package (0x04)
            {
                0x00, 
                0x3C, 
                0x4B, 
                0x4E
            })
            Name (TERR, 0x00)
            Name (TMPP, 0x00)
            Method (_CRT, 0, NotSerialized)
            {
                Store (\_SB.PCI0.LPC0.PMRD (0xE8), Local0)
                Add (Local0, 0x0112, Local0)
                Multiply (Local0, 0x0A, Local0)
                Return (Local0)
            }

            Method (_PSV, 0, NotSerialized)
            {
                Store (DerefOf (Index (LOLM, 0x03)), Local0)
                Decrement (Local0)
                Decrement (Local0)
                Add (Local0, 0x0112, Local0)
                Multiply (Local0, 0x0A, Local0)
                Return (Local0)
            }

            Name (_PSL, Package (0x02)
            {
                \_PR.CPU0, 
                \_PR.CPU1
            })
            Method (_AC0, 0, NotSerialized)
            {
                If (SPDF)
                {
                    Add (DerefOf (Index (Z006, 0x01)), DerefOf (Index (Z007, 0x02
                        )), Local1)
                }
                Else
                {
                    Add (DerefOf (Index (HILM, 0x01)), DerefOf (Index (LOLM, 0x02
                        )), Local1)
                }

                Multiply (Local1, 0x0A, Local1)
                Store (Divide (Local1, 0x02, ), Local0)
                Add (Local0, 0x0AAA, Local0)
                Return (Local0)
            }

            Name (_AL0, Package (0x01)
            {
                FN1
            })
            Method (_AC1, 0, NotSerialized)
            {
                If (SPDF)
                {
                    Add (DerefOf (Index (Z006, 0x00)), DerefOf (Index (Z007, 0x01
                        )), Local1)
                }
                Else
                {
                    Add (DerefOf (Index (HILM, 0x00)), DerefOf (Index (LOLM, 0x01
                        )), Local1)
                }

                Multiply (Local1, 0x0A, Local1)
                Store (Divide (Local1, 0x02, ), Local0)
                Add (Local0, 0x0AAA, Local0)
                Return (Local0)
            }

            Name (_AL1, Package (0x01)
            {
                FN2
            })
            Method (_SCP, 1, NotSerialized)
            {
                If (INIT)
                {
                    Store (Arg0, MODE)
                }
                Else
                {
                    XOr (\_SB.PCI0.LPC0.ACAD.ACFG, One, MODE)
                    Store (One, INIT)
                }

                TCHK ()
                Notify (\_TZ.THRM, 0x81)
            }

            Method (_TMP, 0, NotSerialized)
            {
                If (THIN)
                {
                    TCHK ()
                }

                If (\_TZ.THRM.TERR)
                {
                    Store (Zero, \_TZ.THRM.TERR)
                    Store (DerefOf (Index (LOLM, 0x03)), Local0)
                    Add (Local0, 0x0112, Local0)
                    Multiply (Local0, 0x0A, Local0)
                    Return (Local0)
                }
                Else
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xE7), Local0)
                    If (LLess (Local0, 0x03))
                    {
                        \_SB.PCI0.LPC0.PMMW (0x043F, 0xAA)
                        \_SB.PCI0.LPC0.PMMW (0x01E8, 0x00)
                        Return (0x0B72)
                    }

                    Multiply (Local0, 0x0A, Local0)
                    Add (Local0, 0x0AAA, Local0)
                    If (LGreater (Local0, 0x127A))
                    {
                        Return (0x0E2E)
                    }

                    Return (Local0)
                }
            }

            Name (_TC1, 0x03)
            Name (_TC2, 0x01)
            Name (_TSP, 0x96)
            Name (THIN, 0x01)
            Name (SPDF, 0x00)
            Name (SKEY, 0x00)
            Method (FANC, 0, NotSerialized)
            {
                Acquire (TZ1, 0xFFFF)
                \_SB.Z004 (0x55)
                Return (0x00)
                Store (\_SB.PCI0.LPC0.PMRD (0xFA), Local0)
                \_SB.PCI0.LPC0.SMWT (0x7A, 0x20, 0x01)
                And (Local0, 0x02, Local1)
                If (LNotEqual (Local1, Zero))
                {
                    If (SPDF)
                    {
                        \_SB.PCI0.LPC0.SMWT (0x7A, 0x10, 0x62)
                    }
                    Else
                    {
                        \_SB.PCI0.LPC0.SMWT (0x7A, 0x10, 0x60)
                    }

                    Return (0x00)
                }

                And (Local0, 0x01, Local1)
                If (LNotEqual (Local1, Zero))
                {
                    If (SPDF)
                    {
                        \_SB.PCI0.LPC0.SMWT (0x7A, 0x10, 0x7B)
                    }
                    Else
                    {
                        \_SB.PCI0.LPC0.SMWT (0x7A, 0x10, 0x7B)
                    }
                }
                Else
                {
                    \_SB.PCI0.LPC0.SMWT (0x7A, 0x10, 0xFF)
                }

                Release (TZ1)
            }

            Method (TCHK, 0, NotSerialized)
            {
                Acquire (TZ0, 0xFFFF)
                Store (THRG, Local0)
                And (Local0, 0x04, SPDF)
                And (Local0, 0x02, SKEY)
                And (Local0, 0x0D, Local0)
                Store (Local0, THRG)
                If (THIN)
                {
                    Store (0x00, THIN)
                }

                Store (\_SB.PCI0.LPC0.PMRD (0xAF), Local7)
                And (Local7, 0x04, Local7)
                If (LNotEqual (Local7, Zero))
                {
                    \_SB.PCI0.LPC0.PMMW (0x043F, 0xAA)
                    \_SB.PCI0.LPC0.PMMW (0x01E8, 0x00)
                    Store (One, \_TZ.THRM.TERR)
                }
                Else
                {
                    Store (\_SB.PCI0.LPC0.PMRD (0xE7), Local1)
                    If (LGreater (Local1, 0x7F))
                    {
                        Store (0x5A, Local1)
                        Store (0xE4, DBUG)
                    }

                    Store (0x00, Local3)
                    If (SPDF)
                    {
                        While (LLess (Local3, 0x04))
                        {
                            Store (DerefOf (Index (Z007, Local3)), Local5)
                            Store (DerefOf (Index (Z006, Local3)), Local6)
                            If (LGreater (Local1, Local5))
                            {
                                If (LLess (Local1, Local6))
                                {
                                    \_SB.PCI0.LPC0.PMWT (0xE4, Local6)
                                    \_SB.PCI0.LPC0.PMWT (0xE5, Local5)
                                    If (LEqual (Local3, 0x03))
                                    {
                                        Store (\_SB.PCI0.LPC0.PMRD (0xE8), Local6)
                                        \_SB.PCI0.LPC0.PMWT (0xE4, Local6)
                                    }

                                    Add (Local3, 0x05, Local3)
                                }
                            }

                            Increment (Local3)
                        }
                    }
                    Else
                    {
                        While (LLess (Local3, 0x04))
                        {
                            Store (DerefOf (Index (LOLM, Local3)), Local5)
                            Store (DerefOf (Index (HILM, Local3)), Local6)
                            If (LGreater (Local1, Local5))
                            {
                                If (LLess (Local1, Local6))
                                {
                                    \_SB.PCI0.LPC0.PMWT (0xE4, Local6)
                                    \_SB.PCI0.LPC0.PMWT (0xE5, Local5)
                                    If (LEqual (Local3, 0x03))
                                    {
                                        Store (\_SB.PCI0.LPC0.PMRD (0xE8), Local6)
                                        \_SB.PCI0.LPC0.PMWT (0xE4, Local6)
                                    }

                                    Add (Local3, 0x05, Local3)
                                }
                            }

                            Increment (Local3)
                        }
                    }
                }

                And (\_SB.PCI0.LPC0.PMRD (0xAD), 0xFE, Local5)
                \_SB.PCI0.LPC0.PMWT (0xAD, Local5)
                And (\_SB.PCI0.LPC0.PMRD (0xAF), 0xF8, Local5)
                \_SB.PCI0.LPC0.PMWT (0xAF, Local5)
                If (SKEY)
                {
                    Notify (\_PR.CPU0, 0x80)
                    Notify (\_TZ.THRM, 0x81)
                }

                Notify (\_TZ.THRM, 0x80)
                Release (TZ0)
            }
        }
    }

    Scope (\_SB.PCI0.LPC0)
    {
        OperationRegion (RGA0, PCI_Config, 0xA0, 0x04)
        Field (RGA0, AnyAcc, NoLock, Preserve)
        {
            COMP,   8, 
            ADIO,   4, 
            MIDS,   4, 
            MSSS,   4, 
            FDCP,   2, 
            ADLB,   1, 
                    Offset (0x03), 
            LPTP,   3, 
                ,   1, 
            DVR0,   1, 
            DVR1,   1, 
            DVR2,   1, 
            DVR3,   1
        }

        OperationRegion (RGA1, PCI_Config, 0xA4, 0x04)
        Field (RGA1, AnyAcc, NoLock, Preserve)
        {
            GMPS,   16, 
                    Offset (0x04)
        }

        Method (Z008, 1, NotSerialized)
        {
            Store (\_SB.PCI0.LPC0.COMP, Local0)
            If (LEqual (Arg0, 0x03F8))
            {
                Not (0x01, Local2)
                And (Local0, Local2, Local0)
            }
            Else
            {
                If (LEqual (Arg0, 0x02F8))
                {
                    Not (0x02, Local2)
                    And (Local0, Local2, Local0)
                }
                Else
                {
                    If (LEqual (Arg0, 0x03E8))
                    {
                        Not (0x80, Local2)
                        And (Local0, Local2, Local0)
                    }
                    Else
                    {
                        If (LEqual (Arg0, 0x02E8))
                        {
                            Not (0x20, Local2)
                            And (Local0, Local2, Local0)
                        }
                    }
                }
            }

            Store (Local0, \_SB.PCI0.LPC0.COMP)
        }

        Method (Z009, 1, NotSerialized)
        {
            Store (\_SB.PCI0.LPC0.COMP, Local0)
            If (LEqual (Arg0, 0x03F8))
            {
                Or (0x01, Local0, Local0)
            }
            Else
            {
                If (LEqual (Arg0, 0x02F8))
                {
                    Or (0x02, Local0, Local0)
                }
                Else
                {
                    If (LEqual (Arg0, 0x03E8))
                    {
                        Or (0x80, Local0, Local0)
                    }
                    Else
                    {
                        If (LEqual (Arg0, 0x02E8))
                        {
                            Or (0x20, Local0, Local0)
                        }
                    }
                }
            }

            Store (Local0, \_SB.PCI0.LPC0.COMP)
        }

        Method (Z00A, 1, NotSerialized)
        {
            Store (\_SB.PCI0.LPC0.LPTP, Local0)
            If (LEqual (Arg0, 0x0378))
            {
                Not (0x01, Local2)
                And (Local0, Local2, Local0)
            }
            Else
            {
                If (LEqual (Arg0, 0x0278))
                {
                    Not (0x02, Local2)
                    And (Local0, Local2, Local0)
                }
                Else
                {
                    If (LEqual (Arg0, 0x03BC))
                    {
                        Not (0x04, Local2)
                        And (Local0, Local2, Local0)
                    }
                }
            }

            Store (Local0, \_SB.PCI0.LPC0.LPTP)
        }

        Method (Z00B, 1, NotSerialized)
        {
            Store (\_SB.PCI0.LPC0.LPTP, Local0)
            If (LEqual (Arg0, 0x0378))
            {
                Or (0x01, Local0, Local0)
            }
            Else
            {
                If (LEqual (Arg0, 0x0278))
                {
                    Or (0x02, Local0, Local0)
                }
                Else
                {
                    If (LEqual (Arg0, 0x03BC))
                    {
                        Or (0x04, Local0, Local0)
                    }
                }
            }

            Store (Local0, \_SB.PCI0.LPC0.LPTP)
        }

        Method (Z00C, 1, NotSerialized)
        {
            Store (\_SB.PCI0.LPC0.FDCP, Local0)
            If (LEqual (Arg0, 0x03F0))
            {
                Not (0x01, Local2)
                And (Local0, Local2, Local0)
            }
            Else
            {
                If (LEqual (Arg0, 0x0370))
                {
                    Not (0x02, Local2)
                    And (Local0, Local2, Local0)
                }
            }

            Store (Local0, \_SB.PCI0.LPC0.FDCP)
        }

        Method (Z00D, 1, NotSerialized)
        {
            Store (\_SB.PCI0.LPC0.FDCP, Local0)
            If (LEqual (Arg0, 0x03F0))
            {
                Or (0x01, Local0, Local0)
            }
            Else
            {
                If (LEqual (Arg0, 0x0370))
                {
                    Or (0x02, Local0, Local0)
                }
            }

            Store (Local0, \_SB.PCI0.LPC0.FDCP)
        }

        Method (Z00E, 1, NotSerialized)
        {
            Store (\_SB.PCI0.LPC0.GMPS, Local0)
            If (LEqual (Arg0, 0x0200))
            {
                Not (0xFF, Local2)
                And (Local0, Local2, Local0)
            }

            If (LEqual (Arg0, 0x0208))
            {
                Not (0xFF00, Local2)
                And (Local0, Local2, Local0)
            }

            Store (Local0, \_SB.PCI0.LPC0.GMPS)
        }

        Method (Z00F, 1, NotSerialized)
        {
            Store (\_SB.PCI0.LPC0.GMPS, Local0)
            If (LEqual (Arg0, 0x0200))
            {
                Or (0xFF, Local0, Local0)
            }

            If (LEqual (Arg0, 0x0208))
            {
                Or (0xFF00, Local0, Local0)
            }

            Store (Local0, \_SB.PCI0.LPC0.GMPS)
        }
    }

    OperationRegion (DBGP, SystemIO, 0x80, 0x01)
    Field (DBGP, ByteAcc, NoLock, Preserve)
    {
        DBUG,   8
    }

    OperationRegion (THRO, SystemIO, 0x1010, 0x01)
    Field (THRO, ByteAcc, NoLock, Preserve)
    {
        THRG,   8
    }

    OperationRegion (LDTR, SystemIO, 0x10A6, 0x01)
    Field (LDTR, ByteAcc, NoLock, Preserve)
    {
        LDTC,   1
    }

    OperationRegion (NVGP, SystemIO, 0x14C0, 0x32)
    Field (NVGP, ByteAcc, NoLock, Preserve)
    {
        Z00G,   8, 
        Z00H,   8, 
                Offset (0x04), 
        Z00I,   8, 
        Z00J,   8, 
        Z00K,   8, 
        Z001,   8, 
        Z002,   8, 
        Z003,   8, 
        Z00L,   8, 
        Z00M,   8, 
                Offset (0x17), 
        Z00N,   8, 
                Offset (0x30), 
        Z000,   8, 
        Z005,   8
    }

    OperationRegion (XCMS, SystemIO, 0x72, 0x02)
    Field (XCMS, ByteAcc, NoLock, Preserve)
    {
        Z00O,   8, 
        Z00P,   8
    }

    IndexField (Z00O, Z00P, ByteAcc, NoLock, Preserve)
    {
                Offset (0x6D), 
        DOSF,   8
    }

    Name (FWSO, "FWSO")
}

